/* Sidebar.c generated by valac 0.54.8, the Vala compiler
 * generated from Sidebar.vala, do not modify */

/*-
 * Copyright 2017-2020 elementary, Inc. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>

#define SCRATCH_MAIN_WINDOW_ACTION_PREFIX "win."
#define SCRATCH_MAIN_WINDOW_ACTION_OPEN_FOLDER "action_open_folder"
#define SCRATCH_MAIN_WINDOW_ACTION_COLLAPSE_ALL_FOLDERS "action_collapse_all_folders"
#define SCRATCH_MAIN_WINDOW_ACTION_ORDER_FOLDERS "action_order_folders"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define CODE_TYPE_SIDEBAR (code_sidebar_get_type ())
#define CODE_SIDEBAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CODE_TYPE_SIDEBAR, CodeSidebar))
#define CODE_SIDEBAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CODE_TYPE_SIDEBAR, CodeSidebarClass))
#define CODE_IS_SIDEBAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CODE_TYPE_SIDEBAR))
#define CODE_IS_SIDEBAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CODE_TYPE_SIDEBAR))
#define CODE_SIDEBAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CODE_TYPE_SIDEBAR, CodeSidebarClass))

typedef struct _CodeSidebar CodeSidebar;
typedef struct _CodeSidebarClass CodeSidebarClass;
typedef struct _CodeSidebarPrivate CodeSidebarPrivate;
enum  {
	CODE_SIDEBAR_0_PROPERTY,
	CODE_SIDEBAR_STACK_PROPERTY,
	CODE_SIDEBAR_NUM_PROPERTIES
};
static GParamSpec* code_sidebar_properties[CODE_SIDEBAR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define CODE_TYPE_PANE_SWITCHER (code_pane_switcher_get_type ())
#define CODE_PANE_SWITCHER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CODE_TYPE_PANE_SWITCHER, CodePaneSwitcher))
#define CODE_IS_PANE_SWITCHER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CODE_TYPE_PANE_SWITCHER))
#define CODE_PANE_SWITCHER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), CODE_TYPE_PANE_SWITCHER, CodePaneSwitcherIface))

typedef struct _CodePaneSwitcher CodePaneSwitcher;
typedef struct _CodePaneSwitcherIface CodePaneSwitcherIface;
typedef struct _Block30Data Block30Data;
#define _g_free0(var) (var = (g_free (var), NULL))

struct _CodeSidebar {
	GtkGrid parent_instance;
	CodeSidebarPrivate * priv;
};

struct _CodeSidebarClass {
	GtkGridClass parent_class;
};

struct _CodeSidebarPrivate {
	GtkStack* _stack;
	GtkStackSwitcher* stack_switcher;
};

struct _CodePaneSwitcherIface {
	GTypeInterface parent_iface;
	const gchar* (*get_icon_name) (CodePaneSwitcher* self);
	void (*set_icon_name) (CodePaneSwitcher* self, const gchar* value);
	const gchar* (*get_title) (CodePaneSwitcher* self);
	void (*set_title) (CodePaneSwitcher* self, const gchar* value);
};

struct _Block30Data {
	int _ref_count_;
	CodeSidebar* self;
	CodePaneSwitcher* tab;
};

static gint CodeSidebar_private_offset;
static gpointer code_sidebar_parent_class = NULL;

VALA_EXTERN GType code_sidebar_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CodeSidebar, g_object_unref)
VALA_EXTERN GType code_pane_switcher_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CodePaneSwitcher, g_object_unref)
VALA_EXTERN void code_sidebar_add_tab (CodeSidebar* self,
                           CodePaneSwitcher* tab);
static Block30Data* block30_data_ref (Block30Data* _data30_);
static void block30_data_unref (void * _userdata_);
VALA_EXTERN GtkStack* code_sidebar_get_stack (CodeSidebar* self);
VALA_EXTERN const gchar* code_pane_switcher_get_title (CodePaneSwitcher* self);
VALA_EXTERN const gchar* code_pane_switcher_get_icon_name (CodePaneSwitcher* self);
static void __lambda117_ (Block30Data* _data30_);
static void ___lambda117__g_object_notify (GObject* _sender,
                                    GParamSpec* pspec,
                                    gpointer self);
static void __lambda118_ (Block30Data* _data30_);
static void ___lambda118__g_object_notify (GObject* _sender,
                                    GParamSpec* pspec,
                                    gpointer self);
VALA_EXTERN void code_sidebar_remove_tab (CodeSidebar* self,
                              CodePaneSwitcher* tab);
VALA_EXTERN CodeSidebar* code_sidebar_new (void);
VALA_EXTERN CodeSidebar* code_sidebar_construct (GType object_type);
static void code_sidebar_set_stack (CodeSidebar* self,
                             GtkStack* value);
static GObject * code_sidebar_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties);
static void _code_sidebar___lambda119_ (CodeSidebar* self);
static void __code_sidebar___lambda119__gtk_container_add (GtkContainer* _sender,
                                                    GtkWidget* widget,
                                                    gpointer self);
static void _code_sidebar___lambda120_ (CodeSidebar* self);
static void __code_sidebar___lambda120__gtk_container_remove (GtkContainer* _sender,
                                                       GtkWidget* widget,
                                                       gpointer self);
static void code_sidebar_finalize (GObject * obj);
static GType code_sidebar_get_type_once (void);
static void _vala_code_sidebar_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec);
static void _vala_code_sidebar_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec);

static inline gpointer
code_sidebar_get_instance_private (CodeSidebar* self)
{
	return G_STRUCT_MEMBER_P (self, CodeSidebar_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static Block30Data*
block30_data_ref (Block30Data* _data30_)
{
	g_atomic_int_inc (&_data30_->_ref_count_);
	return _data30_;
}

static void
block30_data_unref (void * _userdata_)
{
	Block30Data* _data30_;
	_data30_ = (Block30Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data30_->_ref_count_)) {
		CodeSidebar* self;
		self = _data30_->self;
		_g_object_unref0 (_data30_->tab);
		_g_object_unref0 (self);
		g_slice_free (Block30Data, _data30_);
	}
}

static void
__lambda117_ (Block30Data* _data30_)
{
	CodeSidebar* self;
	GtkStack* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GValue _tmp3_ = {0};
	self = _data30_->self;
	_tmp0_ = self->priv->_stack;
	_tmp1_ = code_pane_switcher_get_title (_data30_->tab);
	_tmp2_ = _tmp1_;
	g_value_init (&_tmp3_, G_TYPE_STRING);
	g_value_set_string (&_tmp3_, _tmp2_);
	gtk_container_child_set_property ((GtkContainer*) _tmp0_, (GtkWidget*) _data30_->tab, "title", &_tmp3_);
	G_IS_VALUE (&_tmp3_) ? (g_value_unset (&_tmp3_), NULL) : NULL;
}

static void
___lambda117__g_object_notify (GObject* _sender,
                               GParamSpec* pspec,
                               gpointer self)
{
	__lambda117_ (self);
}

static void
__lambda118_ (Block30Data* _data30_)
{
	CodeSidebar* self;
	GtkStack* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GValue _tmp3_ = {0};
	self = _data30_->self;
	_tmp0_ = self->priv->_stack;
	_tmp1_ = code_pane_switcher_get_icon_name (_data30_->tab);
	_tmp2_ = _tmp1_;
	g_value_init (&_tmp3_, G_TYPE_STRING);
	g_value_set_string (&_tmp3_, _tmp2_);
	gtk_container_child_set_property ((GtkContainer*) _tmp0_, (GtkWidget*) _data30_->tab, "icon-name", &_tmp3_);
	G_IS_VALUE (&_tmp3_) ? (g_value_unset (&_tmp3_), NULL) : NULL;
}

static void
___lambda118__g_object_notify (GObject* _sender,
                               GParamSpec* pspec,
                               gpointer self)
{
	__lambda118_ (self);
}

void
code_sidebar_add_tab (CodeSidebar* self,
                      CodePaneSwitcher* tab)
{
	Block30Data* _data30_;
	CodePaneSwitcher* _tmp0_;
	GtkStack* _tmp1_;
	GtkStack* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	GValue _tmp5_ = {0};
	GtkStack* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	GValue _tmp9_ = {0};
	g_return_if_fail (self != NULL);
	g_return_if_fail (tab != NULL);
	_data30_ = g_slice_new0 (Block30Data);
	_data30_->_ref_count_ = 1;
	_data30_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (tab);
	_g_object_unref0 (_data30_->tab);
	_data30_->tab = _tmp0_;
	_tmp1_ = self->priv->_stack;
	gtk_container_add ((GtkContainer*) _tmp1_, (GtkWidget*) _data30_->tab);
	_tmp2_ = self->priv->_stack;
	_tmp3_ = code_pane_switcher_get_title (_data30_->tab);
	_tmp4_ = _tmp3_;
	g_value_init (&_tmp5_, G_TYPE_STRING);
	g_value_set_string (&_tmp5_, _tmp4_);
	gtk_container_child_set_property ((GtkContainer*) _tmp2_, (GtkWidget*) _data30_->tab, "title", &_tmp5_);
	G_IS_VALUE (&_tmp5_) ? (g_value_unset (&_tmp5_), NULL) : NULL;
	_tmp6_ = self->priv->_stack;
	_tmp7_ = code_pane_switcher_get_icon_name (_data30_->tab);
	_tmp8_ = _tmp7_;
	g_value_init (&_tmp9_, G_TYPE_STRING);
	g_value_set_string (&_tmp9_, _tmp8_);
	gtk_container_child_set_property ((GtkContainer*) _tmp6_, (GtkWidget*) _data30_->tab, "icon-name", &_tmp9_);
	G_IS_VALUE (&_tmp9_) ? (g_value_unset (&_tmp9_), NULL) : NULL;
	g_signal_connect_data ((GObject*) _data30_->tab, "notify::title", (GCallback) ___lambda117__g_object_notify, block30_data_ref (_data30_), (GClosureNotify) block30_data_unref, 0);
	g_signal_connect_data ((GObject*) _data30_->tab, "notify::icon-name", (GCallback) ___lambda118__g_object_notify, block30_data_ref (_data30_), (GClosureNotify) block30_data_unref, 0);
	block30_data_unref (_data30_);
	_data30_ = NULL;
}

void
code_sidebar_remove_tab (CodeSidebar* self,
                         CodePaneSwitcher* tab)
{
	GtkStack* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (tab != NULL);
	_tmp0_ = self->priv->_stack;
	gtk_container_remove ((GtkContainer*) _tmp0_, (GtkWidget*) tab);
}

CodeSidebar*
code_sidebar_construct (GType object_type)
{
	CodeSidebar * self = NULL;
	self = (CodeSidebar*) g_object_new (object_type, NULL);
	return self;
}

CodeSidebar*
code_sidebar_new (void)
{
	return code_sidebar_construct (CODE_TYPE_SIDEBAR);
}

GtkStack*
code_sidebar_get_stack (CodeSidebar* self)
{
	GtkStack* result;
	GtkStack* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_stack;
	result = _tmp0_;
	return result;
}

static void
code_sidebar_set_stack (CodeSidebar* self,
                        GtkStack* value)
{
	GtkStack* old_value;
	g_return_if_fail (self != NULL);
	old_value = code_sidebar_get_stack (self);
	if (old_value != value) {
		GtkStack* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_stack);
		self->priv->_stack = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, code_sidebar_properties[CODE_SIDEBAR_STACK_PROPERTY]);
	}
}

static void
_code_sidebar___lambda119_ (CodeSidebar* self)
{
	GtkStack* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	gboolean _tmp3_;
	GtkStack* _tmp6_;
	GtkStack* _tmp7_;
	_tmp0_ = self->priv->_stack;
	_tmp1_ = gtk_container_get_children ((GtkContainer*) _tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_list_length (_tmp2_) > ((guint) 1);
	(_tmp2_ == NULL) ? NULL : (_tmp2_ = (g_list_free (_tmp2_), NULL));
	if (_tmp3_) {
		GtkStackSwitcher* _tmp4_;
		GtkStackSwitcher* _tmp5_;
		_tmp4_ = self->priv->stack_switcher;
		gtk_widget_set_no_show_all ((GtkWidget*) _tmp4_, FALSE);
		_tmp5_ = self->priv->stack_switcher;
		gtk_widget_show_all ((GtkWidget*) _tmp5_);
	}
	_tmp6_ = self->priv->_stack;
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp6_, FALSE);
	_tmp7_ = self->priv->_stack;
	gtk_widget_show_all ((GtkWidget*) _tmp7_);
}

static void
__code_sidebar___lambda119__gtk_container_add (GtkContainer* _sender,
                                               GtkWidget* widget,
                                               gpointer self)
{
	_code_sidebar___lambda119_ ((CodeSidebar*) self);
}

static void
_code_sidebar___lambda120_ (CodeSidebar* self)
{
	GtkStack* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	guint _tmp3_;
	_tmp0_ = self->priv->_stack;
	_tmp1_ = gtk_container_get_children ((GtkContainer*) _tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_list_length (_tmp2_);
	(_tmp2_ == NULL) ? NULL : (_tmp2_ = (g_list_free (_tmp2_), NULL));
	switch (_tmp3_) {
		case 0:
		{
			GtkStack* _tmp4_;
			GtkStack* _tmp5_;
			_tmp4_ = self->priv->_stack;
			gtk_widget_set_no_show_all ((GtkWidget*) _tmp4_, TRUE);
			_tmp5_ = self->priv->_stack;
			gtk_widget_hide ((GtkWidget*) _tmp5_);
			break;
		}
		case 1:
		{
			GtkStackSwitcher* _tmp6_;
			GtkStackSwitcher* _tmp7_;
			_tmp6_ = self->priv->stack_switcher;
			gtk_widget_set_no_show_all ((GtkWidget*) _tmp6_, TRUE);
			_tmp7_ = self->priv->stack_switcher;
			gtk_widget_hide ((GtkWidget*) _tmp7_);
			break;
		}
		default:
		break;
	}
}

static void
__code_sidebar___lambda120__gtk_container_remove (GtkContainer* _sender,
                                                  GtkWidget* widget,
                                                  gpointer self)
{
	_code_sidebar___lambda120_ ((CodeSidebar*) self);
}

static GObject *
code_sidebar_constructor (GType type,
                          guint n_construct_properties,
                          GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	CodeSidebar * self;
	GtkStyleContext* _tmp0_;
	GtkStack* _tmp1_;
	GtkStack* _tmp2_;
	GtkStack* _tmp3_;
	GtkStackSwitcher* _tmp4_;
	GtkStackSwitcher* _tmp5_;
	GtkStackSwitcher* _tmp6_;
	GtkStackSwitcher* _tmp7_;
	GtkStack* _tmp8_;
	GtkStackSwitcher* _tmp9_;
	GtkActionBar* actionbar = NULL;
	GtkActionBar* _tmp10_;
	GtkActionBar* _tmp11_;
	GtkStyleContext* _tmp12_;
	GtkButton* add_folder_button = NULL;
	gchar* _tmp13_;
	gchar* _tmp14_;
	GtkButton* _tmp15_ = NULL;
	GtkMenuItem* collapse_all_menu_item = NULL;
	GtkMenuItem* _tmp16_;
	GtkMenuItem* _tmp17_;
	GtkMenuItem* order_projects_menu_item = NULL;
	GtkMenuItem* _tmp18_;
	GtkMenuItem* _tmp19_;
	GtkMenu* project_menu = NULL;
	GtkMenu* _tmp20_;
	GtkMenu* _tmp21_;
	GtkMenuItem* _tmp22_;
	GtkMenu* _tmp23_;
	GtkMenuItem* _tmp24_;
	GtkMenu* _tmp25_;
	GtkMenuButton* project_more_button = NULL;
	GtkMenuButton* _tmp26_;
	GtkMenuButton* _tmp27_;
	GtkImage* _tmp28_;
	GtkImage* _tmp29_;
	GtkMenuButton* _tmp30_;
	GtkMenu* _tmp31_;
	GtkMenuButton* _tmp32_;
	GtkActionBar* _tmp33_;
	GtkButton* _tmp34_;
	GtkActionBar* _tmp35_;
	GtkMenuButton* _tmp36_;
	GtkStackSwitcher* _tmp37_;
	GtkStack* _tmp38_;
	GtkActionBar* _tmp39_;
	GtkStack* _tmp40_;
	GtkStack* _tmp41_;
	parent_class = G_OBJECT_CLASS (code_sidebar_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CODE_TYPE_SIDEBAR, CodeSidebar);
	gtk_orientable_set_orientation ((GtkOrientable*) self, GTK_ORIENTATION_VERTICAL);
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
	gtk_style_context_add_class (_tmp0_, GTK_STYLE_CLASS_SIDEBAR);
	_tmp1_ = (GtkStack*) gtk_stack_new ();
	g_object_ref_sink (_tmp1_);
	_tmp2_ = _tmp1_;
	code_sidebar_set_stack (self, _tmp2_);
	_g_object_unref0 (_tmp2_);
	_tmp3_ = self->priv->_stack;
	gtk_stack_set_transition_type (_tmp3_, GTK_STACK_TRANSITION_TYPE_SLIDE_LEFT_RIGHT);
	_tmp4_ = (GtkStackSwitcher*) gtk_stack_switcher_new ();
	g_object_ref_sink (_tmp4_);
	_g_object_unref0 (self->priv->stack_switcher);
	self->priv->stack_switcher = _tmp4_;
	_tmp5_ = self->priv->stack_switcher;
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp5_, TRUE);
	_tmp6_ = self->priv->stack_switcher;
	gtk_widget_set_visible ((GtkWidget*) _tmp6_, FALSE);
	_tmp7_ = self->priv->stack_switcher;
	_tmp8_ = self->priv->_stack;
	gtk_stack_switcher_set_stack (_tmp7_, _tmp8_);
	_tmp9_ = self->priv->stack_switcher;
	gtk_box_set_homogeneous ((GtkBox*) _tmp9_, TRUE);
	_tmp10_ = (GtkActionBar*) gtk_action_bar_new ();
	g_object_ref_sink (_tmp10_);
	actionbar = _tmp10_;
	_tmp11_ = actionbar;
	_tmp12_ = gtk_widget_get_style_context ((GtkWidget*) _tmp11_);
	gtk_style_context_add_class (_tmp12_, GTK_STYLE_CLASS_INLINE_TOOLBAR);
	_tmp13_ = g_strdup (SCRATCH_MAIN_WINDOW_ACTION_PREFIX SCRATCH_MAIN_WINDOW_ACTION_OPEN_FOLDER);
	_tmp14_ = g_strdup (_ ("Open Project Folder…"));
	_tmp15_ = (GtkButton*) gtk_button_new_from_icon_name ("folder-open-symbolic", (GtkIconSize) GTK_ICON_SIZE_SMALL_TOOLBAR);
	gtk_actionable_set_action_name ((GtkActionable*) _tmp15_, _tmp13_);
	_g_free0 (_tmp13_);
	gtk_button_set_always_show_image (_tmp15_, TRUE);
	gtk_button_set_label (_tmp15_, _tmp14_);
	_g_free0 (_tmp14_);
	g_object_ref_sink (_tmp15_);
	add_folder_button = _tmp15_;
	_tmp16_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Collapse All"));
	g_object_ref_sink (_tmp16_);
	collapse_all_menu_item = _tmp16_;
	_tmp17_ = collapse_all_menu_item;
	gtk_actionable_set_action_name ((GtkActionable*) _tmp17_, SCRATCH_MAIN_WINDOW_ACTION_PREFIX SCRATCH_MAIN_WINDOW_ACTION_COLLAPSE_ALL_FOLDERS);
	_tmp18_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Alphabetize"));
	g_object_ref_sink (_tmp18_);
	order_projects_menu_item = _tmp18_;
	_tmp19_ = order_projects_menu_item;
	gtk_actionable_set_action_name ((GtkActionable*) _tmp19_, SCRATCH_MAIN_WINDOW_ACTION_PREFIX SCRATCH_MAIN_WINDOW_ACTION_ORDER_FOLDERS);
	_tmp20_ = (GtkMenu*) gtk_menu_new ();
	g_object_ref_sink (_tmp20_);
	project_menu = _tmp20_;
	_tmp21_ = project_menu;
	_tmp22_ = collapse_all_menu_item;
	gtk_menu_shell_append ((GtkMenuShell*) _tmp21_, _tmp22_);
	_tmp23_ = project_menu;
	_tmp24_ = order_projects_menu_item;
	gtk_menu_shell_append ((GtkMenuShell*) _tmp23_, _tmp24_);
	_tmp25_ = project_menu;
	gtk_widget_show_all ((GtkWidget*) _tmp25_);
	_tmp26_ = (GtkMenuButton*) gtk_menu_button_new ();
	g_object_ref_sink (_tmp26_);
	project_more_button = _tmp26_;
	_tmp27_ = project_more_button;
	_tmp28_ = (GtkImage*) gtk_image_new_from_icon_name ("view-more-symbolic", (GtkIconSize) GTK_ICON_SIZE_SMALL_TOOLBAR);
	g_object_ref_sink (_tmp28_);
	_tmp29_ = _tmp28_;
	gtk_button_set_image ((GtkButton*) _tmp27_, (GtkWidget*) _tmp29_);
	_g_object_unref0 (_tmp29_);
	_tmp30_ = project_more_button;
	_tmp31_ = project_menu;
	gtk_menu_button_set_popup (_tmp30_, _tmp31_);
	_tmp32_ = project_more_button;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp32_, _ ("Manage project folders"));
	_tmp33_ = actionbar;
	_tmp34_ = add_folder_button;
	gtk_container_add ((GtkContainer*) _tmp33_, (GtkWidget*) _tmp34_);
	_tmp35_ = actionbar;
	_tmp36_ = project_more_button;
	gtk_action_bar_pack_end (_tmp35_, (GtkWidget*) _tmp36_);
	_tmp37_ = self->priv->stack_switcher;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp37_);
	_tmp38_ = self->priv->_stack;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp38_);
	_tmp39_ = actionbar;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp39_);
	_tmp40_ = self->priv->_stack;
	g_signal_connect_object ((GtkContainer*) _tmp40_, "add", (GCallback) __code_sidebar___lambda119__gtk_container_add, self, 0);
	_tmp41_ = self->priv->_stack;
	g_signal_connect_object ((GtkContainer*) _tmp41_, "remove", (GCallback) __code_sidebar___lambda120__gtk_container_remove, self, 0);
	_g_object_unref0 (project_more_button);
	_g_object_unref0 (project_menu);
	_g_object_unref0 (order_projects_menu_item);
	_g_object_unref0 (collapse_all_menu_item);
	_g_object_unref0 (add_folder_button);
	_g_object_unref0 (actionbar);
	return obj;
}

static void
code_sidebar_class_init (CodeSidebarClass * klass,
                         gpointer klass_data)
{
	code_sidebar_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &CodeSidebar_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_code_sidebar_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_code_sidebar_set_property;
	G_OBJECT_CLASS (klass)->constructor = code_sidebar_constructor;
	G_OBJECT_CLASS (klass)->finalize = code_sidebar_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), CODE_SIDEBAR_STACK_PROPERTY, code_sidebar_properties[CODE_SIDEBAR_STACK_PROPERTY] = g_param_spec_object ("stack", "stack", "stack", gtk_stack_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}

static void
code_sidebar_instance_init (CodeSidebar * self,
                            gpointer klass)
{
	self->priv = code_sidebar_get_instance_private (self);
}

static void
code_sidebar_finalize (GObject * obj)
{
	CodeSidebar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CODE_TYPE_SIDEBAR, CodeSidebar);
	_g_object_unref0 (self->priv->_stack);
	_g_object_unref0 (self->priv->stack_switcher);
	G_OBJECT_CLASS (code_sidebar_parent_class)->finalize (obj);
}

static GType
code_sidebar_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (CodeSidebarClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) code_sidebar_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CodeSidebar), 0, (GInstanceInitFunc) code_sidebar_instance_init, NULL };
	GType code_sidebar_type_id;
	code_sidebar_type_id = g_type_register_static (gtk_grid_get_type (), "CodeSidebar", &g_define_type_info, 0);
	CodeSidebar_private_offset = g_type_add_instance_private (code_sidebar_type_id, sizeof (CodeSidebarPrivate));
	return code_sidebar_type_id;
}

GType
code_sidebar_get_type (void)
{
	static volatile gsize code_sidebar_type_id__volatile = 0;
	if (g_once_init_enter (&code_sidebar_type_id__volatile)) {
		GType code_sidebar_type_id;
		code_sidebar_type_id = code_sidebar_get_type_once ();
		g_once_init_leave (&code_sidebar_type_id__volatile, code_sidebar_type_id);
	}
	return code_sidebar_type_id__volatile;
}

static void
_vala_code_sidebar_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec)
{
	CodeSidebar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CODE_TYPE_SIDEBAR, CodeSidebar);
	switch (property_id) {
		case CODE_SIDEBAR_STACK_PROPERTY:
		g_value_set_object (value, code_sidebar_get_stack (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_code_sidebar_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec)
{
	CodeSidebar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CODE_TYPE_SIDEBAR, CodeSidebar);
	switch (property_id) {
		case CODE_SIDEBAR_STACK_PROPERTY:
		code_sidebar_set_stack (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

