/* SearchBar.c generated by valac 0.54.8, the Vala compiler
 * generated from SearchBar.vala, do not modify */

/*
 * Copyright (C) 2011-2012 Lucas Baudin <xapantu@gmail.com>
 *               2013      Mario Guerriero <mario@elementaryos.org>
 *
 * This file is part of Code.
 *
 * Code is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Code is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "codecore.h"
#include <gtk/gtk.h>
#include <gtksourceview/gtksource.h>
#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>
#include <granite.h>

enum  {
	SCRATCH_WIDGETS_SEARCH_BAR_0_PROPERTY,
	SCRATCH_WIDGETS_SEARCH_BAR_WINDOW_PROPERTY,
	SCRATCH_WIDGETS_SEARCH_BAR_TOOL_CYCLE_SEARCH_PROPERTY,
	SCRATCH_WIDGETS_SEARCH_BAR_NUM_PROPERTIES
};
static GParamSpec* scratch_widgets_search_bar_properties[SCRATCH_WIDGETS_SEARCH_BAR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define __vala_GtkTextIter_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTextIter_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _gtk_widget_path_unref0(var) ((var == NULL) ? NULL : (var = (gtk_widget_path_unref (var), NULL)))
enum  {
	SCRATCH_WIDGETS_SEARCH_BAR_SEARCH_EMPTY_SIGNAL,
	SCRATCH_WIDGETS_SEARCH_BAR_NUM_SIGNALS
};
static guint scratch_widgets_search_bar_signals[SCRATCH_WIDGETS_SEARCH_BAR_NUM_SIGNALS] = {0};

struct _ScratchWidgetsSearchBarPrivate {
	ScratchMainWindow* _window;
	GtkButton* tool_arrow_up;
	GtkButton* tool_arrow_down;
	GtkToggleButton* _tool_cycle_search;
	GtkToggleButton* case_sensitive_button;
	GtkToggleButton* tool_regex_button;
	GtkLabel* search_occurence_count_label;
	GtkButton* replace_tool_button;
	GtkButton* replace_all_tool_button;
	ScratchWidgetsSourceView* text_view;
	GtkTextBuffer* text_buffer;
	GtkSourceSearchContext* search_context;
	guint update_search_label_timeout_id;
};

static gint ScratchWidgetsSearchBar_private_offset;
static gpointer scratch_widgets_search_bar_parent_class = NULL;

static void scratch_widgets_search_bar_cancel_update_search_occurence_label (ScratchWidgetsSearchBar* self);
static void scratch_widgets_search_bar_on_text_buffer_changed (ScratchWidgetsSearchBar* self);
static void _scratch_widgets_search_bar_on_text_buffer_changed_gtk_text_buffer_changed (GtkTextBuffer* _sender,
                                                                                 gpointer self);
static void scratch_widgets_search_bar_update_search_occurence_label (ScratchWidgetsSearchBar* self);
static void scratch_widgets_search_bar_update_tool_arrows (ScratchWidgetsSearchBar* self);
static gboolean scratch_widgets_search_bar_has_matches (ScratchWidgetsSearchBar* self);
static void scratch_widgets_search_bar_update_replace_tool_sensitivities (ScratchWidgetsSearchBar* self,
                                                                   gboolean matches);
static void scratch_widgets_search_bar_on_replace_entry_activate (ScratchWidgetsSearchBar* self);
static void _vala_GtkTextIter_free (GtkTextIter* self);
static GtkTextIter* _vala_GtkTextIter_copy (GtkTextIter* self);
static gboolean scratch_widgets_search_bar_search_for_iter (ScratchWidgetsSearchBar* self,
                                                     GtkTextIter* start_iter,
                                                     GtkTextIter** end_iter);
static void scratch_widgets_search_bar_on_replace_all_entry_activate (ScratchWidgetsSearchBar* self);
static void scratch_widgets_search_bar_on_search_entry_text_changed (ScratchWidgetsSearchBar* self);
static gboolean scratch_widgets_search_bar_is_case_sensitive (ScratchWidgetsSearchBar* self,
                                                       const gchar* search_string);
static gboolean scratch_widgets_search_bar_on_search_entry_focused_in (ScratchWidgetsSearchBar* self,
                                                                GdkEventFocus* event);
static gboolean scratch_widgets_search_bar_search_for_iter_backward (ScratchWidgetsSearchBar* self,
                                                              GtkTextIter* start_iter,
                                                              GtkTextIter** end_iter);
static gboolean scratch_widgets_search_bar_on_search_entry_key_press (ScratchWidgetsSearchBar* self,
                                                               GdkEventKey* event);
static gboolean scratch_widgets_search_bar_on_replace_entry_key_press (ScratchWidgetsSearchBar* self,
                                                                GdkEventKey* event);
static gboolean __lambda101_ (ScratchWidgetsSearchBar* self);
static gboolean ___lambda101__gsource_func (gpointer self);
static GObject * scratch_widgets_search_bar_constructor (GType type,
                                                  guint n_construct_properties,
                                                  GObjectConstructParam * construct_properties);
static void _scratch_widgets_search_bar_search_next_gtk_button_clicked (GtkButton* _sender,
                                                                 gpointer self);
static void _scratch_widgets_search_bar_search_previous_gtk_button_clicked (GtkButton* _sender,
                                                                     gpointer self);
static void _scratch_widgets_search_bar_on_search_entry_text_changed_gtk_button_clicked (GtkButton* _sender,
                                                                                  gpointer self);
static gboolean _scratch_widgets_search_bar___lambda102_ (ScratchWidgetsSearchBar* self,
                                                   GBinding* binding,
                                                   GValue* active_val,
                                                   GValue* tooltip_val);
static gboolean __scratch_widgets_search_bar___lambda102__gbinding_transform_func (GBinding* binding,
                                                                            GValue* from_value,
                                                                            GValue* to_value,
                                                                            gpointer self);
static void _scratch_widgets_search_bar_on_replace_entry_activate_gtk_button_clicked (GtkButton* _sender,
                                                                               gpointer self);
static void _scratch_widgets_search_bar_on_replace_all_entry_activate_gtk_button_clicked (GtkButton* _sender,
                                                                                   gpointer self);
static void _scratch_widgets_search_bar_on_search_entry_text_changed_gtk_editable_changed (GtkEditable* _sender,
                                                                                    gpointer self);
static gboolean _scratch_widgets_search_bar_on_search_entry_key_press_gtk_widget_key_press_event (GtkWidget* _sender,
                                                                                           GdkEventKey* event,
                                                                                           gpointer self);
static gboolean _scratch_widgets_search_bar_on_search_entry_focused_in_gtk_widget_focus_in_event (GtkWidget* _sender,
                                                                                           GdkEventFocus* event,
                                                                                           gpointer self);
static void _scratch_widgets_search_bar_update_search_occurence_label_gtk_search_entry_search_changed (GtkSearchEntry* _sender,
                                                                                                gpointer self);
static void _scratch_widgets_search_bar___lambda103_ (ScratchWidgetsSearchBar* self,
                                               GtkEntryIconPosition p0,
                                               GdkEvent* p1);
static void __scratch_widgets_search_bar___lambda103__gtk_entry_icon_release (GtkEntry* _sender,
                                                                       GtkEntryIconPosition icon_pos,
                                                                       GdkEvent* event,
                                                                       gpointer self);
static void _scratch_widgets_search_bar_on_replace_entry_activate_gtk_entry_activate (GtkEntry* _sender,
                                                                               gpointer self);
static gboolean _scratch_widgets_search_bar_on_replace_entry_key_press_gtk_widget_key_press_event (GtkWidget* _sender,
                                                                                            GdkEventKey* event,
                                                                                            gpointer self);
static void scratch_widgets_search_bar_finalize (GObject * obj);
static GType scratch_widgets_search_bar_get_type_once (void);
static void _vala_scratch_widgets_search_bar_get_property (GObject * object,
                                                    guint property_id,
                                                    GValue * value,
                                                    GParamSpec * pspec);
static void _vala_scratch_widgets_search_bar_set_property (GObject * object,
                                                    guint property_id,
                                                    const GValue * value,
                                                    GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
scratch_widgets_search_bar_get_instance_private (ScratchWidgetsSearchBar* self)
{
	return G_STRUCT_MEMBER_P (self, ScratchWidgetsSearchBar_private_offset);
}

/**
         * Create a new SearchBar widget.
         *
         * following actions : Fetch, ShowGoTo, ShowReplace, or null.
         **/
ScratchWidgetsSearchBar*
scratch_widgets_search_bar_construct (GType object_type,
                                      ScratchMainWindow* window)
{
	ScratchWidgetsSearchBar * self = NULL;
	g_return_val_if_fail (window != NULL, NULL);
	self = (ScratchWidgetsSearchBar*) g_object_new (object_type, "window", window, NULL);
	return self;
}

ScratchWidgetsSearchBar*
scratch_widgets_search_bar_new (ScratchMainWindow* window)
{
	return scratch_widgets_search_bar_construct (SCRATCH_WIDGETS_TYPE_SEARCH_BAR, window);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
_scratch_widgets_search_bar_on_text_buffer_changed_gtk_text_buffer_changed (GtkTextBuffer* _sender,
                                                                            gpointer self)
{
	scratch_widgets_search_bar_on_text_buffer_changed ((ScratchWidgetsSearchBar*) self);
}

void
scratch_widgets_search_bar_set_text_view (ScratchWidgetsSearchBar* self,
                                          ScratchWidgetsSourceView* text_view)
{
	ScratchWidgetsSourceView* _tmp0_;
	GtkTextBuffer* _tmp4_;
	GtkTextBuffer* _tmp5_;
	GtkTextBuffer* _tmp6_;
	GtkTextBuffer* _tmp7_;
	GtkSourceSearchContext* _tmp8_;
	GtkSourceSearchContext* _tmp9_;
	GtkSourceSearchSettings* _tmp10_;
	GtkSourceSearchSettings* _tmp11_;
	GtkToggleButton* _tmp12_;
	gboolean _tmp13_;
	gboolean _tmp14_;
	GtkSourceSearchContext* _tmp15_;
	GtkSourceSearchSettings* _tmp16_;
	GtkSourceSearchSettings* _tmp17_;
	GtkToggleButton* _tmp18_;
	gboolean _tmp19_;
	gboolean _tmp20_;
	GtkSourceSearchContext* _tmp21_;
	GtkSourceSearchSettings* _tmp22_;
	GtkSourceSearchSettings* _tmp23_;
	GtkSearchEntry* _tmp24_;
	const gchar* _tmp25_;
	const gchar* _tmp26_;
	g_return_if_fail (self != NULL);
	scratch_widgets_search_bar_cancel_update_search_occurence_label (self);
	_tmp0_ = _g_object_ref0 (text_view);
	_g_object_unref0 (self->priv->text_view);
	self->priv->text_view = _tmp0_;
	if (text_view == NULL) {
		g_warning ("SearchBar.vala:194: No SourceView is associated with SearchManager!");
		_g_object_unref0 (self->priv->search_context);
		self->priv->search_context = NULL;
		return;
	} else {
		GtkTextBuffer* _tmp1_;
		_tmp1_ = self->priv->text_buffer;
		if (_tmp1_ != NULL) {
			GtkTextBuffer* _tmp2_;
			guint _tmp3_;
			_tmp2_ = self->priv->text_buffer;
			g_signal_parse_name ("changed", gtk_text_buffer_get_type (), &_tmp3_, NULL, FALSE);
			g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _scratch_widgets_search_bar_on_text_buffer_changed_gtk_text_buffer_changed, self);
		}
	}
	_tmp4_ = gtk_text_view_get_buffer ((GtkTextView*) text_view);
	_tmp5_ = _g_object_ref0 (_tmp4_);
	_g_object_unref0 (self->priv->text_buffer);
	self->priv->text_buffer = _tmp5_;
	_tmp6_ = self->priv->text_buffer;
	g_signal_connect_object (_tmp6_, "changed", (GCallback) _scratch_widgets_search_bar_on_text_buffer_changed_gtk_text_buffer_changed, self, 0);
	_tmp7_ = self->priv->text_buffer;
	_tmp8_ = gtk_source_search_context_new (G_TYPE_CHECK_INSTANCE_TYPE (_tmp7_, gtk_source_buffer_get_type ()) ? ((GtkSourceBuffer*) _tmp7_) : NULL, NULL);
	_g_object_unref0 (self->priv->search_context);
	self->priv->search_context = _tmp8_;
	_tmp9_ = self->priv->search_context;
	_tmp10_ = gtk_source_search_context_get_settings (_tmp9_);
	_tmp11_ = _tmp10_;
	_tmp12_ = self->priv->_tool_cycle_search;
	_tmp13_ = gtk_toggle_button_get_active (_tmp12_);
	_tmp14_ = _tmp13_;
	gtk_source_search_settings_set_wrap_around (_tmp11_, _tmp14_);
	_tmp15_ = self->priv->search_context;
	_tmp16_ = gtk_source_search_context_get_settings (_tmp15_);
	_tmp17_ = _tmp16_;
	_tmp18_ = self->priv->tool_regex_button;
	_tmp19_ = gtk_toggle_button_get_active (_tmp18_);
	_tmp20_ = _tmp19_;
	gtk_source_search_settings_set_regex_enabled (_tmp17_, _tmp20_);
	_tmp21_ = self->priv->search_context;
	_tmp22_ = gtk_source_search_context_get_settings (_tmp21_);
	_tmp23_ = _tmp22_;
	_tmp24_ = self->search_entry;
	_tmp25_ = gtk_entry_get_text ((GtkEntry*) _tmp24_);
	_tmp26_ = _tmp25_;
	gtk_source_search_settings_set_search_text (_tmp23_, _tmp26_);
}

static void
scratch_widgets_search_bar_on_text_buffer_changed (ScratchWidgetsSearchBar* self)
{
	gboolean matches = FALSE;
	g_return_if_fail (self != NULL);
	scratch_widgets_search_bar_update_search_occurence_label (self);
	scratch_widgets_search_bar_update_tool_arrows (self);
	matches = scratch_widgets_search_bar_has_matches (self);
	scratch_widgets_search_bar_update_replace_tool_sensitivities (self, matches);
}

static void
_vala_GtkTextIter_free (GtkTextIter* self)
{
	g_boxed_free (gtk_text_iter_get_type (), self);
}

static GtkTextIter*
_vala_GtkTextIter_copy (GtkTextIter* self)
{
	return g_boxed_copy (gtk_text_iter_get_type (), self);
}

static gpointer
__vala_GtkTextIter_copy0 (gpointer self)
{
	return self ? _vala_GtkTextIter_copy (self) : NULL;
}

static void
scratch_widgets_search_bar_on_replace_entry_activate (ScratchWidgetsSearchBar* self)
{
	GtkTextBuffer* _tmp0_;
	GtkTextIter* start_iter = NULL;
	GtkTextIter* end_iter = NULL;
	GtkTextBuffer* _tmp1_;
	GtkTextBuffer* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	GtkTextIter _tmp5_ = {0};
	GtkTextIter _tmp6_;
	GtkTextIter* _tmp7_;
	GtkTextIter* _tmp8_;
	GtkTextIter* _tmp9_ = NULL;
	gboolean _tmp10_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->text_buffer;
	if (_tmp0_ == NULL) {
		g_warning ("SearchBar.vala:218: No valid buffer to replace");
		return;
	}
	_tmp1_ = self->priv->text_buffer;
	_tmp2_ = self->priv->text_buffer;
	g_object_get (_tmp2_, "cursor-position", &_tmp3_, NULL);
	_tmp4_ = _tmp3_;
	gtk_text_buffer_get_iter_at_offset (_tmp1_, &_tmp5_, _tmp4_);
	__vala_GtkTextIter_free0 (start_iter);
	_tmp6_ = _tmp5_;
	_tmp7_ = __vala_GtkTextIter_copy0 (&_tmp6_);
	start_iter = _tmp7_;
	_tmp8_ = start_iter;
	_tmp10_ = scratch_widgets_search_bar_search_for_iter (self, _tmp8_, &_tmp9_);
	__vala_GtkTextIter_free0 (end_iter);
	end_iter = _tmp9_;
	if (_tmp10_) {
		gchar* replace_string = NULL;
		GtkSearchEntry* _tmp11_;
		const gchar* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		_tmp11_ = self->replace_entry;
		_tmp12_ = gtk_entry_get_text ((GtkEntry*) _tmp11_);
		_tmp13_ = _tmp12_;
		_tmp14_ = g_strdup (_tmp13_);
		replace_string = _tmp14_;
		{
			GtkSourceSearchContext* _tmp15_;
			GtkTextIter* _tmp16_;
			GtkTextIter* _tmp17_;
			const gchar* _tmp18_;
			const gchar* _tmp19_;
			gint _tmp20_;
			gint _tmp21_;
			GtkTextIter _tmp22_;
			GtkTextIter _tmp23_;
			gboolean matches = FALSE;
			GtkSearchEntry* _tmp24_;
			const gchar* _tmp25_;
			const gchar* _tmp26_;
			GtkSearchEntry* _tmp27_;
			const gchar* _tmp28_;
			const gchar* _tmp29_;
			scratch_widgets_search_bar_cancel_update_search_occurence_label (self);
			_tmp15_ = self->priv->search_context;
			_tmp16_ = start_iter;
			_tmp17_ = end_iter;
			_tmp18_ = replace_string;
			_tmp19_ = replace_string;
			_tmp20_ = strlen (_tmp19_);
			_tmp21_ = _tmp20_;
			_tmp22_ = *_tmp16_;
			_tmp23_ = *_tmp17_;
			gtk_source_search_context_replace (_tmp15_, &_tmp22_, &_tmp23_, _tmp18_, _tmp21_, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch0_g_error;
			}
			matches = scratch_widgets_search_bar_search (self);
			scratch_widgets_search_bar_update_replace_tool_sensitivities (self, matches);
			scratch_widgets_search_bar_update_tool_arrows (self);
			scratch_widgets_search_bar_update_search_occurence_label (self);
			_tmp24_ = self->search_entry;
			_tmp25_ = gtk_entry_get_text ((GtkEntry*) _tmp24_);
			_tmp26_ = _tmp25_;
			_tmp27_ = self->replace_entry;
			_tmp28_ = gtk_entry_get_text ((GtkEntry*) _tmp27_);
			_tmp29_ = _tmp28_;
			g_debug ("SearchBar.vala:234: Replaced \"%s\" with \"%s\"", _tmp26_, _tmp29_);
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp30_;
			const gchar* _tmp31_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp30_ = e;
			_tmp31_ = _tmp30_->message;
			g_critical ("SearchBar.vala:236: %s", _tmp31_);
			_g_error_free0 (e);
		}
		__finally0:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (replace_string);
			__vala_GtkTextIter_free0 (end_iter);
			__vala_GtkTextIter_free0 (start_iter);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		_g_free0 (replace_string);
	}
	__vala_GtkTextIter_free0 (end_iter);
	__vala_GtkTextIter_free0 (start_iter);
}

static void
scratch_widgets_search_bar_on_replace_all_entry_activate (ScratchWidgetsSearchBar* self)
{
	gboolean _tmp0_ = FALSE;
	GtkTextBuffer* _tmp1_;
	gchar* replace_string = NULL;
	GtkSearchEntry* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	ScratchMainWindow* _tmp9_;
	ScratchServicesDocument* _tmp10_;
	ScratchServicesDocument* _tmp11_;
	ScratchMainWindow* _tmp19_;
	ScratchServicesDocument* _tmp20_;
	ScratchServicesDocument* _tmp21_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp1_ = self->priv->text_buffer;
	if (_tmp1_ == NULL) {
		_tmp0_ = TRUE;
	} else {
		ScratchMainWindow* _tmp2_;
		ScratchServicesDocument* _tmp3_;
		ScratchServicesDocument* _tmp4_;
		_tmp2_ = self->priv->_window;
		_tmp3_ = scratch_main_window_get_current_document (_tmp2_);
		_tmp4_ = _tmp3_;
		_tmp0_ = _tmp4_ == NULL;
		_g_object_unref0 (_tmp4_);
	}
	if (_tmp0_) {
		g_debug ("SearchBar.vala:243: No valid buffer to replace");
		return;
	}
	_tmp5_ = self->replace_entry;
	_tmp6_ = gtk_entry_get_text ((GtkEntry*) _tmp5_);
	_tmp7_ = _tmp6_;
	_tmp8_ = g_strdup (_tmp7_);
	replace_string = _tmp8_;
	_tmp9_ = self->priv->_window;
	_tmp10_ = scratch_main_window_get_current_document (_tmp9_);
	_tmp11_ = _tmp10_;
	scratch_services_document_toggle_changed_handlers (_tmp11_, FALSE);
	_g_object_unref0 (_tmp11_);
	{
		GtkSourceSearchContext* _tmp12_;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
		gint _tmp15_;
		gint _tmp16_;
		scratch_widgets_search_bar_cancel_update_search_occurence_label (self);
		_tmp12_ = self->priv->search_context;
		_tmp13_ = replace_string;
		_tmp14_ = replace_string;
		_tmp15_ = strlen (_tmp14_);
		_tmp16_ = _tmp15_;
		gtk_source_search_context_replace_all (_tmp12_, _tmp13_, _tmp16_, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		scratch_widgets_search_bar_update_tool_arrows (self);
		scratch_widgets_search_bar_update_search_occurence_label (self);
		scratch_widgets_search_bar_update_replace_tool_sensitivities (self, FALSE);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp17_;
		const gchar* _tmp18_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp17_ = e;
		_tmp18_ = _tmp17_->message;
		g_critical ("SearchBar.vala:256: %s", _tmp18_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_free0 (replace_string);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_tmp19_ = self->priv->_window;
	_tmp20_ = scratch_main_window_get_current_document (_tmp19_);
	_tmp21_ = _tmp20_;
	scratch_services_document_toggle_changed_handlers (_tmp21_, TRUE);
	_g_object_unref0 (_tmp21_);
	_g_free0 (replace_string);
}

void
scratch_widgets_search_bar_set_search_string (ScratchWidgetsSearchBar* self,
                                              const gchar* to_search)
{
	GtkSearchEntry* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (to_search != NULL);
	_tmp0_ = self->search_entry;
	gtk_entry_set_text ((GtkEntry*) _tmp0_, to_search);
}

static void
scratch_widgets_search_bar_on_search_entry_text_changed (ScratchWidgetsSearchBar* self)
{
	GtkSourceSearchContext* _tmp0_;
	gchar* search_string = NULL;
	GtkSearchEntry* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	GtkSourceSearchContext* _tmp5_;
	GtkSourceSearchSettings* _tmp6_;
	GtkSourceSearchSettings* _tmp7_;
	const gchar* _tmp8_;
	gboolean case_sensitive = FALSE;
	const gchar* _tmp9_;
	GtkSourceSearchContext* _tmp10_;
	GtkSourceSearchSettings* _tmp11_;
	GtkSourceSearchSettings* _tmp12_;
	GtkSourceSearchContext* _tmp13_;
	GtkSourceSearchSettings* _tmp14_;
	GtkSourceSearchSettings* _tmp15_;
	GtkToggleButton* _tmp16_;
	gboolean _tmp17_;
	gboolean _tmp18_;
	gboolean matches = FALSE;
	GtkSearchEntry* _tmp19_;
	const gchar* _tmp20_;
	const gchar* _tmp21_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->search_context;
	if (_tmp0_ == NULL) {
		g_debug ("SearchBar.vala:268: search entry changed with null context");
		return;
	}
	_tmp1_ = self->search_entry;
	_tmp2_ = gtk_entry_get_text ((GtkEntry*) _tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = g_strdup (_tmp3_);
	search_string = _tmp4_;
	_tmp5_ = self->priv->search_context;
	_tmp6_ = gtk_source_search_context_get_settings (_tmp5_);
	_tmp7_ = _tmp6_;
	_tmp8_ = search_string;
	gtk_source_search_settings_set_search_text (_tmp7_, _tmp8_);
	_tmp9_ = search_string;
	case_sensitive = scratch_widgets_search_bar_is_case_sensitive (self, _tmp9_);
	_tmp10_ = self->priv->search_context;
	_tmp11_ = gtk_source_search_context_get_settings (_tmp10_);
	_tmp12_ = _tmp11_;
	gtk_source_search_settings_set_case_sensitive (_tmp12_, case_sensitive);
	_tmp13_ = self->priv->search_context;
	_tmp14_ = gtk_source_search_context_get_settings (_tmp13_);
	_tmp15_ = _tmp14_;
	_tmp16_ = self->priv->tool_regex_button;
	_tmp17_ = gtk_toggle_button_get_active (_tmp16_);
	_tmp18_ = _tmp17_;
	gtk_source_search_settings_set_regex_enabled (_tmp15_, _tmp18_);
	matches = scratch_widgets_search_bar_search (self);
	scratch_widgets_search_bar_update_replace_tool_sensitivities (self, matches);
	scratch_widgets_search_bar_update_search_occurence_label (self);
	scratch_widgets_search_bar_update_tool_arrows (self);
	_tmp19_ = self->search_entry;
	_tmp20_ = gtk_entry_get_text ((GtkEntry*) _tmp19_);
	_tmp21_ = _tmp20_;
	if (g_strcmp0 (_tmp21_, "") == 0) {
		g_signal_emit (self, scratch_widgets_search_bar_signals[SCRATCH_WIDGETS_SEARCH_BAR_SEARCH_EMPTY_SIGNAL], 0);
	}
	_g_free0 (search_string);
}

static void
scratch_widgets_search_bar_update_replace_tool_sensitivities (ScratchWidgetsSearchBar* self,
                                                              gboolean matches)
{
	gboolean _tmp0_ = FALSE;
	GtkButton* _tmp4_;
	gboolean _tmp5_ = FALSE;
	GtkButton* _tmp9_;
	g_return_if_fail (self != NULL);
	if (matches) {
		GtkSearchEntry* _tmp1_;
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		_tmp1_ = self->search_entry;
		_tmp2_ = gtk_entry_get_text ((GtkEntry*) _tmp1_);
		_tmp3_ = _tmp2_;
		_tmp0_ = g_strcmp0 (_tmp3_, "") != 0;
	} else {
		_tmp0_ = FALSE;
	}
	_tmp4_ = self->priv->replace_tool_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp4_, _tmp0_);
	if (matches) {
		GtkSearchEntry* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		_tmp6_ = self->search_entry;
		_tmp7_ = gtk_entry_get_text ((GtkEntry*) _tmp6_);
		_tmp8_ = _tmp7_;
		_tmp5_ = g_strcmp0 (_tmp8_, "") != 0;
	} else {
		_tmp5_ = FALSE;
	}
	_tmp9_ = self->priv->replace_all_tool_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp9_, _tmp5_);
}

static gboolean
scratch_widgets_search_bar_on_search_entry_focused_in (ScratchWidgetsSearchBar* self,
                                                       GdkEventFocus* event)
{
	GtkTextBuffer* _tmp0_;
	GtkTextIter* iter = NULL;
	GtkTextIter* start_iter = NULL;
	GtkTextIter* end_iter = NULL;
	GtkTextBuffer* _tmp1_;
	GtkTextBuffer* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	GtkTextIter _tmp5_ = {0};
	GtkTextIter _tmp6_;
	GtkTextIter* _tmp7_;
	GtkTextIter* _tmp8_;
	GtkTextIter* _tmp9_;
	gboolean found = FALSE;
	GtkSourceSearchContext* _tmp10_;
	GtkTextIter* _tmp11_;
	GtkTextIter _tmp12_;
	GtkTextIter _tmp13_ = {0};
	GtkTextIter _tmp14_ = {0};
	gboolean _tmp15_;
	GtkTextIter _tmp16_;
	GtkTextIter* _tmp17_;
	GtkTextIter _tmp18_;
	GtkTextIter* _tmp19_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = self->priv->text_buffer;
	if (_tmp0_ == NULL) {
		result = FALSE;
		return result;
	}
	_tmp1_ = self->priv->text_buffer;
	_tmp2_ = self->priv->text_buffer;
	g_object_get (_tmp2_, "cursor-position", &_tmp3_, NULL);
	_tmp4_ = _tmp3_;
	gtk_text_buffer_get_iter_at_offset (_tmp1_, &_tmp5_, _tmp4_);
	__vala_GtkTextIter_free0 (iter);
	_tmp6_ = _tmp5_;
	_tmp7_ = __vala_GtkTextIter_copy0 (&_tmp6_);
	iter = _tmp7_;
	_tmp8_ = iter;
	_tmp9_ = __vala_GtkTextIter_copy0 (_tmp8_);
	__vala_GtkTextIter_free0 (end_iter);
	end_iter = _tmp9_;
	_tmp10_ = self->priv->search_context;
	_tmp11_ = iter;
	_tmp12_ = *_tmp11_;
	_tmp15_ = gtk_source_search_context_forward (_tmp10_, &_tmp12_, &_tmp13_, &_tmp14_, NULL);
	__vala_GtkTextIter_free0 (start_iter);
	_tmp16_ = _tmp13_;
	_tmp17_ = __vala_GtkTextIter_copy0 (&_tmp16_);
	start_iter = _tmp17_;
	__vala_GtkTextIter_free0 (end_iter);
	_tmp18_ = _tmp14_;
	_tmp19_ = __vala_GtkTextIter_copy0 (&_tmp18_);
	end_iter = _tmp19_;
	found = _tmp15_;
	if (found) {
		GtkSearchEntry* _tmp20_;
		GtkStyleContext* _tmp21_;
		GtkSearchEntry* _tmp22_;
		_tmp20_ = self->search_entry;
		_tmp21_ = gtk_widget_get_style_context ((GtkWidget*) _tmp20_);
		gtk_style_context_remove_class (_tmp21_, GTK_STYLE_CLASS_ERROR);
		_tmp22_ = self->search_entry;
		g_object_set ((GtkEntry*) _tmp22_, "primary-icon-name", "edit-find-symbolic", NULL);
		result = TRUE;
		__vala_GtkTextIter_free0 (end_iter);
		__vala_GtkTextIter_free0 (start_iter);
		__vala_GtkTextIter_free0 (iter);
		return result;
	} else {
		GtkSearchEntry* _tmp23_;
		const gchar* _tmp24_;
		const gchar* _tmp25_;
		_tmp23_ = self->search_entry;
		_tmp24_ = gtk_entry_get_text ((GtkEntry*) _tmp23_);
		_tmp25_ = _tmp24_;
		if (g_strcmp0 (_tmp25_, "") != 0) {
			GtkSearchEntry* _tmp26_;
			GtkStyleContext* _tmp27_;
			GtkSearchEntry* _tmp28_;
			_tmp26_ = self->search_entry;
			_tmp27_ = gtk_widget_get_style_context ((GtkWidget*) _tmp26_);
			gtk_style_context_add_class (_tmp27_, GTK_STYLE_CLASS_ERROR);
			_tmp28_ = self->search_entry;
			g_object_set ((GtkEntry*) _tmp28_, "primary-icon-name", "dialog-error-symbolic", NULL);
		}
		result = FALSE;
		__vala_GtkTextIter_free0 (end_iter);
		__vala_GtkTextIter_free0 (start_iter);
		__vala_GtkTextIter_free0 (iter);
		return result;
	}
}

gboolean
scratch_widgets_search_bar_search (ScratchWidgetsSearchBar* self)
{
	GtkSourceSearchContext* _tmp0_;
	GtkSourceSearchContext* _tmp1_;
	GtkSourceSearchContext* _tmp3_;
	GtkTextIter* start_iter = NULL;
	GtkTextIter* end_iter = NULL;
	GtkTextBuffer* _tmp4_;
	GtkTextBuffer* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	GtkTextIter _tmp8_ = {0};
	GtkTextIter _tmp9_;
	GtkTextIter* _tmp10_;
	GtkTextIter* _tmp11_;
	GtkTextIter* _tmp12_ = NULL;
	gboolean _tmp13_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->search_context;
	if (_tmp0_ == NULL) {
		result = FALSE;
		return result;
	}
	_tmp1_ = self->priv->search_context;
	gtk_source_search_context_set_highlight (_tmp1_, FALSE);
	if (!scratch_widgets_search_bar_has_matches (self)) {
		GtkSearchEntry* _tmp2_;
		g_debug ("SearchBar.vala:325: Can't search anything in a non-existent buffer and" \
"/or without anything to search.");
		_tmp2_ = self->search_entry;
		g_object_set ((GtkEntry*) _tmp2_, "primary-icon-name", "edit-find-symbolic", NULL);
		result = FALSE;
		return result;
	}
	_tmp3_ = self->priv->search_context;
	gtk_source_search_context_set_highlight (_tmp3_, TRUE);
	_tmp4_ = self->priv->text_buffer;
	_tmp5_ = self->priv->text_buffer;
	g_object_get (_tmp5_, "cursor-position", &_tmp6_, NULL);
	_tmp7_ = _tmp6_;
	gtk_text_buffer_get_iter_at_offset (_tmp4_, &_tmp8_, _tmp7_);
	__vala_GtkTextIter_free0 (start_iter);
	_tmp9_ = _tmp8_;
	_tmp10_ = __vala_GtkTextIter_copy0 (&_tmp9_);
	start_iter = _tmp10_;
	_tmp11_ = start_iter;
	_tmp13_ = scratch_widgets_search_bar_search_for_iter (self, _tmp11_, &_tmp12_);
	__vala_GtkTextIter_free0 (end_iter);
	end_iter = _tmp12_;
	if (_tmp13_) {
		GtkSearchEntry* _tmp14_;
		GtkStyleContext* _tmp15_;
		GtkSearchEntry* _tmp16_;
		_tmp14_ = self->search_entry;
		_tmp15_ = gtk_widget_get_style_context ((GtkWidget*) _tmp14_);
		gtk_style_context_remove_class (_tmp15_, GTK_STYLE_CLASS_ERROR);
		_tmp16_ = self->search_entry;
		g_object_set ((GtkEntry*) _tmp16_, "primary-icon-name", "edit-find-symbolic", NULL);
	} else {
		GtkTextBuffer* _tmp17_;
		GtkTextIter _tmp18_ = {0};
		GtkTextIter _tmp19_;
		GtkTextIter* _tmp20_;
		GtkTextIter* _tmp21_;
		GtkTextIter* _tmp22_ = NULL;
		gboolean _tmp23_;
		_tmp17_ = self->priv->text_buffer;
		gtk_text_buffer_get_start_iter (_tmp17_, &_tmp18_);
		__vala_GtkTextIter_free0 (start_iter);
		_tmp19_ = _tmp18_;
		_tmp20_ = __vala_GtkTextIter_copy0 (&_tmp19_);
		start_iter = _tmp20_;
		_tmp21_ = start_iter;
		_tmp23_ = scratch_widgets_search_bar_search_for_iter (self, _tmp21_, &_tmp22_);
		__vala_GtkTextIter_free0 (end_iter);
		end_iter = _tmp22_;
		if (_tmp23_) {
			GtkSearchEntry* _tmp24_;
			GtkStyleContext* _tmp25_;
			GtkSearchEntry* _tmp26_;
			_tmp24_ = self->search_entry;
			_tmp25_ = gtk_widget_get_style_context ((GtkWidget*) _tmp24_);
			gtk_style_context_remove_class (_tmp25_, GTK_STYLE_CLASS_ERROR);
			_tmp26_ = self->search_entry;
			g_object_set ((GtkEntry*) _tmp26_, "primary-icon-name", "edit-find-symbolic", NULL);
		} else {
			GtkSearchEntry* _tmp27_;
			const gchar* _tmp28_;
			const gchar* _tmp29_;
			GtkTextIter* _tmp30_;
			GtkTextBuffer* _tmp31_;
			GtkTextIter* _tmp32_;
			GtkTextIter* _tmp33_;
			GtkTextIter _tmp34_;
			GtkTextIter _tmp35_;
			GtkSearchEntry* _tmp36_;
			GtkStyleContext* _tmp37_;
			GtkSearchEntry* _tmp38_;
			_tmp27_ = self->search_entry;
			_tmp28_ = gtk_entry_get_text ((GtkEntry*) _tmp27_);
			_tmp29_ = _tmp28_;
			g_debug ("SearchBar.vala:344: Not found: \"%s\"", _tmp29_);
			_tmp30_ = start_iter;
			gtk_text_iter_set_offset (_tmp30_, -1);
			_tmp31_ = self->priv->text_buffer;
			_tmp32_ = start_iter;
			_tmp33_ = start_iter;
			_tmp34_ = *_tmp32_;
			_tmp35_ = *_tmp33_;
			gtk_text_buffer_select_range (_tmp31_, &_tmp34_, &_tmp35_);
			_tmp36_ = self->search_entry;
			_tmp37_ = gtk_widget_get_style_context ((GtkWidget*) _tmp36_);
			gtk_style_context_add_class (_tmp37_, GTK_STYLE_CLASS_ERROR);
			_tmp38_ = self->search_entry;
			g_object_set ((GtkEntry*) _tmp38_, "primary-icon-name", "dialog-error-symbolic", NULL);
			result = FALSE;
			__vala_GtkTextIter_free0 (end_iter);
			__vala_GtkTextIter_free0 (start_iter);
			return result;
		}
	}
	result = TRUE;
	__vala_GtkTextIter_free0 (end_iter);
	__vala_GtkTextIter_free0 (start_iter);
	return result;
}

void
scratch_widgets_search_bar_highlight_none (ScratchWidgetsSearchBar* self)
{
	GtkSourceSearchContext* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->search_context;
	if (_tmp0_ != NULL) {
		GtkSourceSearchContext* _tmp1_;
		_tmp1_ = self->priv->search_context;
		gtk_source_search_context_set_highlight (_tmp1_, FALSE);
	}
}

static gboolean
scratch_widgets_search_bar_has_matches (ScratchWidgetsSearchBar* self)
{
	gboolean _tmp0_ = FALSE;
	GtkTextBuffer* _tmp1_;
	gboolean has_wrapped_around = FALSE;
	GtkTextIter* start_iter = NULL;
	GtkTextIter* end_iter = NULL;
	GtkTextBuffer* _tmp5_;
	GtkTextIter _tmp6_ = {0};
	GtkTextIter _tmp7_;
	GtkTextIter* _tmp8_;
	GtkSourceSearchContext* _tmp9_;
	GtkTextIter* _tmp10_;
	GtkTextIter _tmp11_;
	GtkTextIter _tmp12_ = {0};
	GtkTextIter _tmp13_ = {0};
	gboolean _tmp14_ = FALSE;
	gboolean _tmp15_;
	GtkTextIter _tmp16_;
	GtkTextIter* _tmp17_;
	GtkTextIter _tmp18_;
	GtkTextIter* _tmp19_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp1_ = self->priv->text_buffer;
	if (_tmp1_ == NULL) {
		_tmp0_ = TRUE;
	} else {
		GtkSearchEntry* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		_tmp2_ = self->search_entry;
		_tmp3_ = gtk_entry_get_text ((GtkEntry*) _tmp2_);
		_tmp4_ = _tmp3_;
		_tmp0_ = g_strcmp0 (_tmp4_, "") == 0;
	}
	if (_tmp0_) {
		result = FALSE;
		return result;
	}
	_tmp5_ = self->priv->text_buffer;
	gtk_text_buffer_get_start_iter (_tmp5_, &_tmp6_);
	__vala_GtkTextIter_free0 (start_iter);
	_tmp7_ = _tmp6_;
	_tmp8_ = __vala_GtkTextIter_copy0 (&_tmp7_);
	start_iter = _tmp8_;
	_tmp9_ = self->priv->search_context;
	_tmp10_ = start_iter;
	_tmp11_ = *_tmp10_;
	_tmp15_ = gtk_source_search_context_forward (_tmp9_, &_tmp11_, &_tmp12_, &_tmp13_, &_tmp14_);
	__vala_GtkTextIter_free0 (start_iter);
	_tmp16_ = _tmp12_;
	_tmp17_ = __vala_GtkTextIter_copy0 (&_tmp16_);
	start_iter = _tmp17_;
	__vala_GtkTextIter_free0 (end_iter);
	_tmp18_ = _tmp13_;
	_tmp19_ = __vala_GtkTextIter_copy0 (&_tmp18_);
	end_iter = _tmp19_;
	has_wrapped_around = _tmp14_;
	result = _tmp15_;
	__vala_GtkTextIter_free0 (end_iter);
	__vala_GtkTextIter_free0 (start_iter);
	return result;
}

static gboolean
scratch_widgets_search_bar_search_for_iter (ScratchWidgetsSearchBar* self,
                                            GtkTextIter* start_iter,
                                            GtkTextIter** end_iter)
{
	GtkTextIter* _vala_end_iter = NULL;
	GtkSourceSearchContext* _tmp0_;
	GtkTextIter* _tmp1_;
	gboolean has_wrapped_around = FALSE;
	gboolean found = FALSE;
	GtkSourceSearchContext* _tmp2_;
	GtkTextIter _tmp3_;
	GtkTextIter _tmp4_ = {0};
	GtkTextIter _tmp5_ = {0};
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_;
	GtkTextIter _tmp8_;
	GtkTextIter _tmp9_;
	GtkTextIter* _tmp10_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->search_context;
	if (_tmp0_ == NULL) {
		g_critical ("SearchBar.vala:375: Trying to search forwards with no search context");
		result = FALSE;
		if (end_iter) {
			*end_iter = _vala_end_iter;
		} else {
			__vala_GtkTextIter_free0 (_vala_end_iter);
		}
		return result;
	}
	_tmp1_ = __vala_GtkTextIter_copy0 (start_iter);
	__vala_GtkTextIter_free0 (_vala_end_iter);
	_vala_end_iter = _tmp1_;
	_tmp2_ = self->priv->search_context;
	_tmp3_ = *start_iter;
	_tmp7_ = gtk_source_search_context_forward (_tmp2_, &_tmp3_, &_tmp4_, &_tmp5_, &_tmp6_);
	_tmp8_ = _tmp4_;
	start_iter = &_tmp8_;
	__vala_GtkTextIter_free0 (_vala_end_iter);
	_tmp9_ = _tmp5_;
	_tmp10_ = __vala_GtkTextIter_copy0 (&_tmp9_);
	_vala_end_iter = _tmp10_;
	has_wrapped_around = _tmp6_;
	found = _tmp7_;
	if (found) {
		GtkTextBuffer* _tmp11_;
		GtkTextIter* _tmp12_;
		GtkTextIter _tmp13_;
		GtkTextIter _tmp14_;
		ScratchWidgetsSourceView* _tmp15_;
		GtkTextIter _tmp16_;
		_tmp11_ = self->priv->text_buffer;
		_tmp12_ = _vala_end_iter;
		_tmp13_ = *start_iter;
		_tmp14_ = *_tmp12_;
		gtk_text_buffer_select_range (_tmp11_, &_tmp13_, &_tmp14_);
		if (has_wrapped_around) {
			gtk_text_iter_backward_lines (start_iter, 3);
		} else {
			gtk_text_iter_forward_lines (start_iter, 3);
		}
		_tmp15_ = self->priv->text_view;
		_tmp16_ = *start_iter;
		gtk_text_view_scroll_to_iter ((GtkTextView*) _tmp15_, &_tmp16_, (gdouble) 0, FALSE, (gdouble) 0, (gdouble) 0);
	}
	result = found;
	if (end_iter) {
		*end_iter = _vala_end_iter;
	} else {
		__vala_GtkTextIter_free0 (_vala_end_iter);
	}
	return result;
}

static gboolean
scratch_widgets_search_bar_search_for_iter_backward (ScratchWidgetsSearchBar* self,
                                                     GtkTextIter* start_iter,
                                                     GtkTextIter** end_iter)
{
	GtkTextIter* _vala_end_iter = NULL;
	GtkSourceSearchContext* _tmp0_;
	GtkTextIter* _tmp1_;
	gboolean has_wrapped_around = FALSE;
	gboolean found = FALSE;
	GtkSourceSearchContext* _tmp2_;
	GtkTextIter _tmp3_;
	GtkTextIter _tmp4_ = {0};
	GtkTextIter _tmp5_ = {0};
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_;
	GtkTextIter _tmp8_;
	GtkTextIter _tmp9_;
	GtkTextIter* _tmp10_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->search_context;
	if (_tmp0_ == NULL) {
		g_critical ("SearchBar.vala:397: Trying to search backwards with no search context");
		result = FALSE;
		if (end_iter) {
			*end_iter = _vala_end_iter;
		} else {
			__vala_GtkTextIter_free0 (_vala_end_iter);
		}
		return result;
	}
	_tmp1_ = __vala_GtkTextIter_copy0 (start_iter);
	__vala_GtkTextIter_free0 (_vala_end_iter);
	_vala_end_iter = _tmp1_;
	_tmp2_ = self->priv->search_context;
	_tmp3_ = *start_iter;
	_tmp7_ = gtk_source_search_context_backward (_tmp2_, &_tmp3_, &_tmp4_, &_tmp5_, &_tmp6_);
	_tmp8_ = _tmp4_;
	start_iter = &_tmp8_;
	__vala_GtkTextIter_free0 (_vala_end_iter);
	_tmp9_ = _tmp5_;
	_tmp10_ = __vala_GtkTextIter_copy0 (&_tmp9_);
	_vala_end_iter = _tmp10_;
	has_wrapped_around = _tmp6_;
	found = _tmp7_;
	if (found) {
		GtkTextBuffer* _tmp11_;
		GtkTextIter* _tmp12_;
		GtkTextIter _tmp13_;
		GtkTextIter _tmp14_;
		ScratchWidgetsSourceView* _tmp15_;
		GtkTextIter _tmp16_;
		_tmp11_ = self->priv->text_buffer;
		_tmp12_ = _vala_end_iter;
		_tmp13_ = *start_iter;
		_tmp14_ = *_tmp12_;
		gtk_text_buffer_select_range (_tmp11_, &_tmp13_, &_tmp14_);
		if (has_wrapped_around) {
			gtk_text_iter_forward_lines (start_iter, 3);
		} else {
			gtk_text_iter_backward_lines (start_iter, 3);
		}
		_tmp15_ = self->priv->text_view;
		_tmp16_ = *start_iter;
		gtk_text_view_scroll_to_iter ((GtkTextView*) _tmp15_, &_tmp16_, (gdouble) 0, FALSE, (gdouble) 0, (gdouble) 0);
	}
	result = found;
	if (end_iter) {
		*end_iter = _vala_end_iter;
	} else {
		__vala_GtkTextIter_free0 (_vala_end_iter);
	}
	return result;
}

void
scratch_widgets_search_bar_search_previous (ScratchWidgetsSearchBar* self)
{
	GtkTextIter* start_iter = NULL;
	GtkTextIter* end_iter = NULL;
	GtkTextBuffer* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->text_buffer;
	if (_tmp0_ != NULL) {
		GtkTextBuffer* _tmp1_;
		GtkTextIter _tmp2_ = {0};
		GtkTextIter _tmp3_ = {0};
		GtkTextIter _tmp4_;
		GtkTextIter* _tmp5_;
		GtkTextIter _tmp6_;
		GtkTextIter* _tmp7_;
		gboolean _tmp8_ = FALSE;
		GtkTextIter* _tmp9_;
		GtkTextIter* _tmp10_ = NULL;
		gboolean _tmp11_;
		_tmp1_ = self->priv->text_buffer;
		gtk_text_buffer_get_selection_bounds (_tmp1_, &_tmp2_, &_tmp3_);
		__vala_GtkTextIter_free0 (start_iter);
		_tmp4_ = _tmp2_;
		_tmp5_ = __vala_GtkTextIter_copy0 (&_tmp4_);
		start_iter = _tmp5_;
		__vala_GtkTextIter_free0 (end_iter);
		_tmp6_ = _tmp3_;
		_tmp7_ = __vala_GtkTextIter_copy0 (&_tmp6_);
		end_iter = _tmp7_;
		_tmp9_ = start_iter;
		_tmp11_ = scratch_widgets_search_bar_search_for_iter_backward (self, _tmp9_, &_tmp10_);
		__vala_GtkTextIter_free0 (end_iter);
		end_iter = _tmp10_;
		if (!_tmp11_) {
			GtkToggleButton* _tmp12_;
			gboolean _tmp13_;
			gboolean _tmp14_;
			_tmp12_ = self->priv->_tool_cycle_search;
			_tmp13_ = gtk_toggle_button_get_active (_tmp12_);
			_tmp14_ = _tmp13_;
			_tmp8_ = _tmp14_;
		} else {
			_tmp8_ = FALSE;
		}
		if (_tmp8_) {
			GtkTextBuffer* _tmp15_;
			GtkTextIter _tmp16_ = {0};
			GtkTextIter _tmp17_;
			GtkTextIter* _tmp18_;
			GtkTextIter* _tmp19_;
			GtkTextIter* _tmp20_ = NULL;
			_tmp15_ = self->priv->text_buffer;
			gtk_text_buffer_get_end_iter (_tmp15_, &_tmp16_);
			__vala_GtkTextIter_free0 (start_iter);
			_tmp17_ = _tmp16_;
			_tmp18_ = __vala_GtkTextIter_copy0 (&_tmp17_);
			start_iter = _tmp18_;
			_tmp19_ = start_iter;
			scratch_widgets_search_bar_search_for_iter_backward (self, _tmp19_, &_tmp20_);
			__vala_GtkTextIter_free0 (end_iter);
			end_iter = _tmp20_;
		}
		scratch_widgets_search_bar_update_tool_arrows (self);
		scratch_widgets_search_bar_update_search_occurence_label (self);
	}
	__vala_GtkTextIter_free0 (end_iter);
	__vala_GtkTextIter_free0 (start_iter);
}

void
scratch_widgets_search_bar_search_next (ScratchWidgetsSearchBar* self)
{
	GtkTextIter* start_iter = NULL;
	GtkTextIter* end_iter = NULL;
	GtkTextIter* end_iter_tmp = NULL;
	GtkTextBuffer* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->text_buffer;
	if (_tmp0_ != NULL) {
		GtkTextBuffer* _tmp1_;
		GtkTextIter _tmp2_ = {0};
		GtkTextIter _tmp3_ = {0};
		GtkTextIter _tmp4_;
		GtkTextIter* _tmp5_;
		GtkTextIter _tmp6_;
		GtkTextIter* _tmp7_;
		gboolean _tmp8_ = FALSE;
		GtkTextIter* _tmp9_;
		GtkTextIter* _tmp10_ = NULL;
		gboolean _tmp11_;
		_tmp1_ = self->priv->text_buffer;
		gtk_text_buffer_get_selection_bounds (_tmp1_, &_tmp2_, &_tmp3_);
		__vala_GtkTextIter_free0 (start_iter);
		_tmp4_ = _tmp2_;
		_tmp5_ = __vala_GtkTextIter_copy0 (&_tmp4_);
		start_iter = _tmp5_;
		__vala_GtkTextIter_free0 (end_iter);
		_tmp6_ = _tmp3_;
		_tmp7_ = __vala_GtkTextIter_copy0 (&_tmp6_);
		end_iter = _tmp7_;
		_tmp9_ = end_iter;
		_tmp11_ = scratch_widgets_search_bar_search_for_iter (self, _tmp9_, &_tmp10_);
		__vala_GtkTextIter_free0 (end_iter_tmp);
		end_iter_tmp = _tmp10_;
		if (!_tmp11_) {
			GtkToggleButton* _tmp12_;
			gboolean _tmp13_;
			gboolean _tmp14_;
			_tmp12_ = self->priv->_tool_cycle_search;
			_tmp13_ = gtk_toggle_button_get_active (_tmp12_);
			_tmp14_ = _tmp13_;
			_tmp8_ = _tmp14_;
		} else {
			_tmp8_ = FALSE;
		}
		if (_tmp8_) {
			GtkTextBuffer* _tmp15_;
			GtkTextIter _tmp16_ = {0};
			GtkTextIter _tmp17_;
			GtkTextIter* _tmp18_;
			GtkTextIter* _tmp19_;
			GtkTextIter* _tmp20_ = NULL;
			_tmp15_ = self->priv->text_buffer;
			gtk_text_buffer_get_start_iter (_tmp15_, &_tmp16_);
			__vala_GtkTextIter_free0 (start_iter);
			_tmp17_ = _tmp16_;
			_tmp18_ = __vala_GtkTextIter_copy0 (&_tmp17_);
			start_iter = _tmp18_;
			_tmp19_ = start_iter;
			scratch_widgets_search_bar_search_for_iter (self, _tmp19_, &_tmp20_);
			__vala_GtkTextIter_free0 (end_iter);
			end_iter = _tmp20_;
		}
		scratch_widgets_search_bar_update_tool_arrows (self);
		scratch_widgets_search_bar_update_search_occurence_label (self);
	}
	__vala_GtkTextIter_free0 (end_iter_tmp);
	__vala_GtkTextIter_free0 (end_iter);
	__vala_GtkTextIter_free0 (start_iter);
}

static void
scratch_widgets_search_bar_update_tool_arrows (ScratchWidgetsSearchBar* self)
{
	gboolean _tmp0_ = FALSE;
	GtkButton* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp1_ = self->priv->tool_arrow_up;
	if (_tmp1_ != NULL) {
		GtkButton* _tmp2_;
		_tmp2_ = self->priv->tool_arrow_down;
		_tmp0_ = _tmp2_ != NULL;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		GtkSearchEntry* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		_tmp3_ = self->search_entry;
		_tmp4_ = gtk_entry_get_text ((GtkEntry*) _tmp3_);
		_tmp5_ = _tmp4_;
		if (g_strcmp0 (_tmp5_, "") == 0) {
			GtkButton* _tmp6_;
			GtkButton* _tmp7_;
			_tmp6_ = self->priv->tool_arrow_up;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp6_, FALSE);
			_tmp7_ = self->priv->tool_arrow_down;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp7_, FALSE);
		} else {
			GtkTextBuffer* _tmp8_;
			_tmp8_ = self->priv->text_buffer;
			if (_tmp8_ != NULL) {
				GtkToggleButton* _tmp9_;
				gboolean _tmp10_;
				gboolean _tmp11_;
				GtkTextIter* start_iter = NULL;
				GtkTextIter* end_iter = NULL;
				GtkTextIter* tmp_start_iter = NULL;
				GtkTextIter* tmp_end_iter = NULL;
				gboolean is_in_start = FALSE;
				gboolean is_in_end = FALSE;
				GtkTextBuffer* _tmp14_;
				GtkTextIter _tmp15_ = {0};
				GtkTextIter _tmp16_;
				GtkTextIter* _tmp17_;
				GtkTextBuffer* _tmp18_;
				GtkTextIter _tmp19_ = {0};
				GtkTextIter _tmp20_;
				GtkTextIter* _tmp21_;
				GtkTextBuffer* _tmp22_;
				GtkTextIter _tmp23_ = {0};
				GtkTextIter _tmp24_ = {0};
				GtkTextIter _tmp25_;
				GtkTextIter* _tmp26_;
				GtkTextIter _tmp27_;
				GtkTextIter* _tmp28_;
				GtkTextIter* _tmp29_;
				GtkTextIter* _tmp30_;
				GtkTextIter _tmp31_;
				GtkTextIter* _tmp32_;
				GtkTextIter* _tmp33_;
				GtkTextIter _tmp34_;
				_tmp9_ = self->priv->_tool_cycle_search;
				_tmp10_ = gtk_toggle_button_get_active (_tmp9_);
				_tmp11_ = _tmp10_;
				if (_tmp11_) {
					GtkButton* _tmp12_;
					GtkButton* _tmp13_;
					_tmp12_ = self->priv->tool_arrow_down;
					gtk_widget_set_sensitive ((GtkWidget*) _tmp12_, TRUE);
					_tmp13_ = self->priv->tool_arrow_up;
					gtk_widget_set_sensitive ((GtkWidget*) _tmp13_, TRUE);
					return;
				}
				_tmp14_ = self->priv->text_buffer;
				gtk_text_buffer_get_start_iter (_tmp14_, &_tmp15_);
				__vala_GtkTextIter_free0 (tmp_start_iter);
				_tmp16_ = _tmp15_;
				_tmp17_ = __vala_GtkTextIter_copy0 (&_tmp16_);
				tmp_start_iter = _tmp17_;
				_tmp18_ = self->priv->text_buffer;
				gtk_text_buffer_get_end_iter (_tmp18_, &_tmp19_);
				__vala_GtkTextIter_free0 (tmp_end_iter);
				_tmp20_ = _tmp19_;
				_tmp21_ = __vala_GtkTextIter_copy0 (&_tmp20_);
				tmp_end_iter = _tmp21_;
				_tmp22_ = self->priv->text_buffer;
				gtk_text_buffer_get_selection_bounds (_tmp22_, &_tmp23_, &_tmp24_);
				__vala_GtkTextIter_free0 (start_iter);
				_tmp25_ = _tmp23_;
				_tmp26_ = __vala_GtkTextIter_copy0 (&_tmp25_);
				start_iter = _tmp26_;
				__vala_GtkTextIter_free0 (end_iter);
				_tmp27_ = _tmp24_;
				_tmp28_ = __vala_GtkTextIter_copy0 (&_tmp27_);
				end_iter = _tmp28_;
				_tmp29_ = start_iter;
				_tmp30_ = tmp_start_iter;
				_tmp31_ = *_tmp30_;
				is_in_start = gtk_text_iter_compare (_tmp29_, &_tmp31_) == 0;
				_tmp32_ = end_iter;
				_tmp33_ = tmp_end_iter;
				_tmp34_ = *_tmp33_;
				is_in_end = gtk_text_iter_compare (_tmp32_, &_tmp34_) == 0;
				if (!is_in_end) {
					GtkButton* _tmp35_;
					GtkSourceSearchContext* _tmp36_;
					GtkTextIter* _tmp37_;
					GtkTextIter _tmp38_;
					GtkTextIter _tmp39_ = {0};
					GtkTextIter _tmp40_ = {0};
					gboolean _tmp41_;
					GtkTextIter _tmp42_;
					GtkTextIter* _tmp43_;
					GtkTextIter _tmp44_;
					GtkTextIter* _tmp45_;
					_tmp35_ = self->priv->tool_arrow_down;
					_tmp36_ = self->priv->search_context;
					_tmp37_ = end_iter;
					_tmp38_ = *_tmp37_;
					_tmp41_ = gtk_source_search_context_forward (_tmp36_, &_tmp38_, &_tmp39_, &_tmp40_, NULL);
					__vala_GtkTextIter_free0 (tmp_start_iter);
					_tmp42_ = _tmp39_;
					_tmp43_ = __vala_GtkTextIter_copy0 (&_tmp42_);
					tmp_start_iter = _tmp43_;
					__vala_GtkTextIter_free0 (tmp_end_iter);
					_tmp44_ = _tmp40_;
					_tmp45_ = __vala_GtkTextIter_copy0 (&_tmp44_);
					tmp_end_iter = _tmp45_;
					gtk_widget_set_sensitive ((GtkWidget*) _tmp35_, _tmp41_);
				} else {
					GtkButton* _tmp46_;
					_tmp46_ = self->priv->tool_arrow_down;
					gtk_widget_set_sensitive ((GtkWidget*) _tmp46_, FALSE);
				}
				if (!is_in_start) {
					GtkButton* _tmp47_;
					GtkSourceSearchContext* _tmp48_;
					GtkTextIter* _tmp49_;
					GtkTextIter _tmp50_;
					GtkTextIter _tmp51_ = {0};
					GtkTextIter _tmp52_ = {0};
					gboolean _tmp53_;
					GtkTextIter _tmp54_;
					GtkTextIter* _tmp55_;
					GtkTextIter _tmp56_;
					GtkTextIter* _tmp57_;
					_tmp47_ = self->priv->tool_arrow_up;
					_tmp48_ = self->priv->search_context;
					_tmp49_ = start_iter;
					_tmp50_ = *_tmp49_;
					_tmp53_ = gtk_source_search_context_backward (_tmp48_, &_tmp50_, &_tmp51_, &_tmp52_, NULL);
					__vala_GtkTextIter_free0 (tmp_start_iter);
					_tmp54_ = _tmp51_;
					_tmp55_ = __vala_GtkTextIter_copy0 (&_tmp54_);
					tmp_start_iter = _tmp55_;
					__vala_GtkTextIter_free0 (end_iter);
					_tmp56_ = _tmp52_;
					_tmp57_ = __vala_GtkTextIter_copy0 (&_tmp56_);
					end_iter = _tmp57_;
					gtk_widget_set_sensitive ((GtkWidget*) _tmp47_, _tmp53_);
				} else {
					GtkButton* _tmp58_;
					_tmp58_ = self->priv->tool_arrow_up;
					gtk_widget_set_sensitive ((GtkWidget*) _tmp58_, FALSE);
				}
				__vala_GtkTextIter_free0 (tmp_end_iter);
				__vala_GtkTextIter_free0 (tmp_start_iter);
				__vala_GtkTextIter_free0 (end_iter);
				__vala_GtkTextIter_free0 (start_iter);
			}
		}
	}
}

static gboolean
scratch_widgets_search_bar_on_search_entry_key_press (ScratchWidgetsSearchBar* self,
                                                      GdkEventKey* event)
{
	GtkSearchEntry* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* key = NULL;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	GQuark _tmp10_ = 0U;
	static GQuark _tmp9_label0 = 0;
	static GQuark _tmp9_label1 = 0;
	static GQuark _tmp9_label2 = 0;
	static GQuark _tmp9_label3 = 0;
	static GQuark _tmp9_label4 = 0;
	static GQuark _tmp9_label5 = 0;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = self->search_entry;
	_tmp1_ = gtk_entry_get_text ((GtkEntry*) _tmp0_);
	_tmp2_ = _tmp1_;
	if (g_strcmp0 (_tmp2_, "") == 0) {
		result = FALSE;
		return result;
	}
	_tmp3_ = gdk_keyval_name (event->keyval);
	_tmp4_ = g_strdup (_tmp3_);
	key = _tmp4_;
	if ((event->state & GDK_SHIFT_MASK) == GDK_SHIFT_MASK) {
		const gchar* _tmp5_;
		gchar* _tmp6_;
		_tmp5_ = key;
		_tmp6_ = g_strconcat ("<Shift>", _tmp5_, NULL);
		_g_free0 (key);
		key = _tmp6_;
	}
	_tmp7_ = key;
	_tmp8_ = _tmp7_;
	_tmp10_ = (NULL == _tmp8_) ? 0 : g_quark_from_string (_tmp8_);
	if ((_tmp10_ == ((0 != _tmp9_label0) ? _tmp9_label0 : (_tmp9_label0 = g_quark_from_static_string ("<Shift>Return")))) || (_tmp10_ == ((0 != _tmp9_label1) ? _tmp9_label1 : (_tmp9_label1 = g_quark_from_static_string ("Up"))))) {
		switch (0) {
			default:
			{
				scratch_widgets_search_bar_search_previous (self);
				result = TRUE;
				_g_free0 (key);
				return result;
			}
		}
	} else if ((_tmp10_ == ((0 != _tmp9_label2) ? _tmp9_label2 : (_tmp9_label2 = g_quark_from_static_string ("Return")))) || (_tmp10_ == ((0 != _tmp9_label3) ? _tmp9_label3 : (_tmp9_label3 = g_quark_from_static_string ("Down"))))) {
		switch (0) {
			default:
			{
				scratch_widgets_search_bar_search_next (self);
				result = TRUE;
				_g_free0 (key);
				return result;
			}
		}
	} else if (_tmp10_ == ((0 != _tmp9_label4) ? _tmp9_label4 : (_tmp9_label4 = g_quark_from_static_string ("Escape")))) {
		switch (0) {
			default:
			{
				ScratchWidgetsSourceView* _tmp11_;
				_tmp11_ = self->priv->text_view;
				gtk_widget_grab_focus ((GtkWidget*) _tmp11_);
				result = TRUE;
				_g_free0 (key);
				return result;
			}
		}
	} else if (_tmp10_ == ((0 != _tmp9_label5) ? _tmp9_label5 : (_tmp9_label5 = g_quark_from_static_string ("Tab")))) {
		switch (0) {
			default:
			{
				GtkSearchEntry* _tmp12_;
				gboolean _tmp13_;
				gboolean _tmp14_;
				_tmp12_ = self->search_entry;
				g_object_get ((GtkWidget*) _tmp12_, "is-focus", &_tmp13_, NULL);
				_tmp14_ = _tmp13_;
				if (_tmp14_) {
					GtkSearchEntry* _tmp15_;
					_tmp15_ = self->replace_entry;
					gtk_widget_grab_focus ((GtkWidget*) _tmp15_);
				}
				result = TRUE;
				_g_free0 (key);
				return result;
			}
		}
	}
	result = FALSE;
	_g_free0 (key);
	return result;
}

static gboolean
scratch_widgets_search_bar_on_replace_entry_key_press (ScratchWidgetsSearchBar* self,
                                                       GdkEventKey* event)
{
	GtkSearchEntry* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	GQuark _tmp6_ = 0U;
	static GQuark _tmp5_label0 = 0;
	static GQuark _tmp5_label1 = 0;
	static GQuark _tmp5_label2 = 0;
	static GQuark _tmp5_label3 = 0;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = self->search_entry;
	_tmp1_ = gtk_entry_get_text ((GtkEntry*) _tmp0_);
	_tmp2_ = _tmp1_;
	if (g_strcmp0 (_tmp2_, "") == 0) {
		result = FALSE;
		return result;
	}
	_tmp3_ = gdk_keyval_name (event->keyval);
	_tmp4_ = _tmp3_;
	_tmp6_ = (NULL == _tmp4_) ? 0 : g_quark_from_string (_tmp4_);
	if (_tmp6_ == ((0 != _tmp5_label0) ? _tmp5_label0 : (_tmp5_label0 = g_quark_from_static_string ("Up")))) {
		switch (0) {
			default:
			{
				scratch_widgets_search_bar_search_previous (self);
				result = TRUE;
				return result;
			}
		}
	} else if (_tmp6_ == ((0 != _tmp5_label1) ? _tmp5_label1 : (_tmp5_label1 = g_quark_from_static_string ("Down")))) {
		switch (0) {
			default:
			{
				scratch_widgets_search_bar_search_next (self);
				result = TRUE;
				return result;
			}
		}
	} else if (_tmp6_ == ((0 != _tmp5_label2) ? _tmp5_label2 : (_tmp5_label2 = g_quark_from_static_string ("Escape")))) {
		switch (0) {
			default:
			{
				ScratchWidgetsSourceView* _tmp7_;
				_tmp7_ = self->priv->text_view;
				gtk_widget_grab_focus ((GtkWidget*) _tmp7_);
				result = TRUE;
				return result;
			}
		}
	} else if (_tmp6_ == ((0 != _tmp5_label3) ? _tmp5_label3 : (_tmp5_label3 = g_quark_from_static_string ("Tab")))) {
		switch (0) {
			default:
			{
				GtkSearchEntry* _tmp8_;
				gboolean _tmp9_;
				gboolean _tmp10_;
				_tmp8_ = self->replace_entry;
				g_object_get ((GtkWidget*) _tmp8_, "is-focus", &_tmp9_, NULL);
				_tmp10_ = _tmp9_;
				if (_tmp10_) {
					GtkSearchEntry* _tmp11_;
					_tmp11_ = self->search_entry;
					gtk_widget_grab_focus ((GtkWidget*) _tmp11_);
				}
				result = TRUE;
				return result;
			}
		}
	}
	result = FALSE;
	return result;
}

static gboolean
scratch_widgets_search_bar_is_case_sensitive (ScratchWidgetsSearchBar* self,
                                              const gchar* search_string)
{
	gboolean _tmp0_ = FALSE;
	GtkToggleButton* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (search_string != NULL, FALSE);
	_tmp1_ = self->priv->case_sensitive_button;
	_tmp2_ = gtk_toggle_button_get_active (_tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_) {
		_tmp0_ = TRUE;
	} else {
		gboolean _tmp4_ = FALSE;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gboolean _tmp7_;
		_tmp5_ = g_utf8_strup (search_string, (gssize) -1);
		_tmp6_ = _tmp5_;
		_tmp7_ = g_strcmp0 (_tmp6_, search_string) == 0;
		_g_free0 (_tmp6_);
		if (_tmp7_) {
			_tmp4_ = TRUE;
		} else {
			gchar* _tmp8_;
			gchar* _tmp9_;
			_tmp8_ = g_utf8_strdown (search_string, (gssize) -1);
			_tmp9_ = _tmp8_;
			_tmp4_ = g_strcmp0 (_tmp9_, search_string) == 0;
			_g_free0 (_tmp9_);
		}
		_tmp0_ = !_tmp4_;
	}
	result = _tmp0_;
	return result;
}

static void
scratch_widgets_search_bar_cancel_update_search_occurence_label (ScratchWidgetsSearchBar* self)
{
	g_return_if_fail (self != NULL);
	if (self->priv->update_search_label_timeout_id > ((guint) 0)) {
		g_source_remove (self->priv->update_search_label_timeout_id);
		self->priv->update_search_label_timeout_id = (guint) 0;
	}
}

static gboolean
__lambda101_ (ScratchWidgetsSearchBar* self)
{
	GtkSourceSearchContext* _tmp0_;
	GtkTextIter* iter = NULL;
	GtkTextIter* start_iter = NULL;
	GtkTextIter* end_iter = NULL;
	GtkTextBuffer* _tmp1_;
	GtkTextBuffer* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	GtkTextIter _tmp5_ = {0};
	GtkTextIter _tmp6_;
	GtkTextIter* _tmp7_;
	gint count_of_search = 0;
	GtkSourceSearchContext* _tmp8_;
	gint location_of_search = 0;
	gboolean found = FALSE;
	GtkSourceSearchContext* _tmp9_;
	GtkTextIter* _tmp10_;
	GtkTextIter _tmp11_;
	GtkTextIter _tmp12_ = {0};
	GtkTextIter _tmp13_ = {0};
	gboolean _tmp14_;
	GtkTextIter _tmp15_;
	GtkTextIter* _tmp16_;
	GtkTextIter _tmp17_;
	GtkTextIter* _tmp18_;
	gboolean _tmp19_ = FALSE;
	gboolean _tmp25_ = FALSE;
	gboolean result = FALSE;
	self->priv->update_search_label_timeout_id = (guint) 0;
	_tmp0_ = self->priv->search_context;
	if (_tmp0_ == NULL) {
		g_warning ("SearchBar.vala:570: update occurrence with null context");
		result = G_SOURCE_REMOVE;
		return result;
	}
	_tmp1_ = self->priv->text_buffer;
	_tmp2_ = self->priv->text_buffer;
	g_object_get (_tmp2_, "cursor-position", &_tmp3_, NULL);
	_tmp4_ = _tmp3_;
	gtk_text_buffer_get_iter_at_offset (_tmp1_, &_tmp5_, _tmp4_);
	__vala_GtkTextIter_free0 (iter);
	_tmp6_ = _tmp5_;
	_tmp7_ = __vala_GtkTextIter_copy0 (&_tmp6_);
	iter = _tmp7_;
	_tmp8_ = self->priv->search_context;
	count_of_search = gtk_source_search_context_get_occurrences_count (_tmp8_);
	location_of_search = -1;
	_tmp9_ = self->priv->search_context;
	_tmp10_ = iter;
	_tmp11_ = *_tmp10_;
	_tmp14_ = gtk_source_search_context_forward (_tmp9_, &_tmp11_, &_tmp12_, &_tmp13_, NULL);
	__vala_GtkTextIter_free0 (start_iter);
	_tmp15_ = _tmp12_;
	_tmp16_ = __vala_GtkTextIter_copy0 (&_tmp15_);
	start_iter = _tmp16_;
	__vala_GtkTextIter_free0 (end_iter);
	_tmp17_ = _tmp13_;
	_tmp18_ = __vala_GtkTextIter_copy0 (&_tmp17_);
	end_iter = _tmp18_;
	found = _tmp14_;
	if (count_of_search > 0) {
		_tmp19_ = found;
	} else {
		_tmp19_ = FALSE;
	}
	if (_tmp19_) {
		GtkSourceSearchContext* _tmp20_;
		GtkTextIter* _tmp21_;
		GtkTextIter* _tmp22_;
		GtkTextIter _tmp23_;
		GtkTextIter _tmp24_;
		_tmp20_ = self->priv->search_context;
		_tmp21_ = start_iter;
		_tmp22_ = end_iter;
		_tmp23_ = *_tmp21_;
		_tmp24_ = *_tmp22_;
		location_of_search = gtk_source_search_context_get_occurrence_position (_tmp20_, &_tmp23_, &_tmp24_);
	}
	if (count_of_search > 0) {
		_tmp25_ = location_of_search > 0;
	} else {
		_tmp25_ = FALSE;
	}
	if (_tmp25_) {
		GtkLabel* _tmp26_;
		gchar* _tmp27_;
		gchar* _tmp28_;
		_tmp26_ = self->priv->search_occurence_count_label;
		_tmp27_ = g_strdup_printf (_ ("%d of %d"), location_of_search, count_of_search);
		_tmp28_ = _tmp27_;
		gtk_label_set_label (_tmp26_, _tmp28_);
		_g_free0 (_tmp28_);
	} else {
		gboolean _tmp29_ = FALSE;
		if (count_of_search == -1) {
			GtkLabel* _tmp30_;
			const gchar* _tmp31_;
			const gchar* _tmp32_;
			_tmp30_ = self->priv->search_occurence_count_label;
			_tmp31_ = gtk_label_get_label (_tmp30_);
			_tmp32_ = _tmp31_;
			_tmp29_ = g_strcmp0 (_tmp32_, _ ("no results")) != 0;
		} else {
			_tmp29_ = FALSE;
		}
		if (_tmp29_) {
		} else {
			GtkLabel* _tmp33_;
			_tmp33_ = self->priv->search_occurence_count_label;
			gtk_label_set_label (_tmp33_, _ ("no results"));
		}
	}
	result = G_SOURCE_REMOVE;
	__vala_GtkTextIter_free0 (end_iter);
	__vala_GtkTextIter_free0 (start_iter);
	__vala_GtkTextIter_free0 (iter);
	return result;
}

static gboolean
___lambda101__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda101_ ((ScratchWidgetsSearchBar*) self);
	return result;
}

static void
scratch_widgets_search_bar_update_search_occurence_label (ScratchWidgetsSearchBar* self)
{
	g_return_if_fail (self != NULL);
	scratch_widgets_search_bar_cancel_update_search_occurence_label (self);
	self->priv->update_search_label_timeout_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 100, ___lambda101__gsource_func, g_object_ref (self), g_object_unref);
}

ScratchMainWindow*
scratch_widgets_search_bar_get_window (ScratchWidgetsSearchBar* self)
{
	ScratchMainWindow* result;
	ScratchMainWindow* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_window;
	result = _tmp0_;
	return result;
}

static void
scratch_widgets_search_bar_set_window (ScratchWidgetsSearchBar* self,
                                       ScratchMainWindow* value)
{
	ScratchMainWindow* old_value;
	g_return_if_fail (self != NULL);
	old_value = scratch_widgets_search_bar_get_window (self);
	if (old_value != value) {
		self->priv->_window = value;
		g_object_notify_by_pspec ((GObject *) self, scratch_widgets_search_bar_properties[SCRATCH_WIDGETS_SEARCH_BAR_WINDOW_PROPERTY]);
	}
}

GtkToggleButton*
scratch_widgets_search_bar_get_tool_cycle_search (ScratchWidgetsSearchBar* self)
{
	GtkToggleButton* result;
	GtkToggleButton* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_tool_cycle_search;
	result = _tmp0_;
	return result;
}

static void
scratch_widgets_search_bar_set_tool_cycle_search (ScratchWidgetsSearchBar* self,
                                                  GtkToggleButton* value)
{
	GtkToggleButton* old_value;
	g_return_if_fail (self != NULL);
	old_value = scratch_widgets_search_bar_get_tool_cycle_search (self);
	if (old_value != value) {
		GtkToggleButton* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_tool_cycle_search);
		self->priv->_tool_cycle_search = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, scratch_widgets_search_bar_properties[SCRATCH_WIDGETS_SEARCH_BAR_TOOL_CYCLE_SEARCH_PROPERTY]);
	}
}

static void
_scratch_widgets_search_bar_search_next_gtk_button_clicked (GtkButton* _sender,
                                                            gpointer self)
{
	scratch_widgets_search_bar_search_next ((ScratchWidgetsSearchBar*) self);
}

static void
_scratch_widgets_search_bar_search_previous_gtk_button_clicked (GtkButton* _sender,
                                                                gpointer self)
{
	scratch_widgets_search_bar_search_previous ((ScratchWidgetsSearchBar*) self);
}

static void
_scratch_widgets_search_bar_on_search_entry_text_changed_gtk_button_clicked (GtkButton* _sender,
                                                                             gpointer self)
{
	scratch_widgets_search_bar_on_search_entry_text_changed ((ScratchWidgetsSearchBar*) self);
}

static gboolean
_scratch_widgets_search_bar___lambda102_ (ScratchWidgetsSearchBar* self,
                                          GBinding* binding,
                                          GValue* active_val,
                                          GValue* tooltip_val)
{
	const gchar* _tmp0_ = NULL;
	GObject* _tmp1_;
	GObject* _tmp2_;
	g_return_val_if_fail (binding != NULL, FALSE);
	g_return_val_if_fail (active_val != NULL, FALSE);
	g_return_val_if_fail (tooltip_val != NULL, FALSE);
	if (g_value_get_boolean (active_val)) {
		_tmp0_ = _ ("Case Sensitive");
	} else {
		_tmp0_ = _ ("Case Insensitive");
	}
	_tmp1_ = g_binding_get_target (binding);
	_tmp2_ = _tmp1_;
	gtk_widget_set_tooltip_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_widget_get_type (), GtkWidget), _tmp0_);
}

static gboolean
__scratch_widgets_search_bar___lambda102__gbinding_transform_func (GBinding* binding,
                                                                   GValue* from_value,
                                                                   GValue* to_value,
                                                                   gpointer self)
{
	gboolean result;
	result = _scratch_widgets_search_bar___lambda102_ ((ScratchWidgetsSearchBar*) self, binding, from_value, to_value);
	return result;
}

static void
_scratch_widgets_search_bar_on_replace_entry_activate_gtk_button_clicked (GtkButton* _sender,
                                                                          gpointer self)
{
	scratch_widgets_search_bar_on_replace_entry_activate ((ScratchWidgetsSearchBar*) self);
}

static void
_scratch_widgets_search_bar_on_replace_all_entry_activate_gtk_button_clicked (GtkButton* _sender,
                                                                              gpointer self)
{
	scratch_widgets_search_bar_on_replace_all_entry_activate ((ScratchWidgetsSearchBar*) self);
}

static void
_scratch_widgets_search_bar_on_search_entry_text_changed_gtk_editable_changed (GtkEditable* _sender,
                                                                               gpointer self)
{
	scratch_widgets_search_bar_on_search_entry_text_changed ((ScratchWidgetsSearchBar*) self);
}

static gboolean
_scratch_widgets_search_bar_on_search_entry_key_press_gtk_widget_key_press_event (GtkWidget* _sender,
                                                                                  GdkEventKey* event,
                                                                                  gpointer self)
{
	gboolean result;
	result = scratch_widgets_search_bar_on_search_entry_key_press ((ScratchWidgetsSearchBar*) self, event);
	return result;
}

static gboolean
_scratch_widgets_search_bar_on_search_entry_focused_in_gtk_widget_focus_in_event (GtkWidget* _sender,
                                                                                  GdkEventFocus* event,
                                                                                  gpointer self)
{
	gboolean result;
	result = scratch_widgets_search_bar_on_search_entry_focused_in ((ScratchWidgetsSearchBar*) self, event);
	return result;
}

static void
_scratch_widgets_search_bar_update_search_occurence_label_gtk_search_entry_search_changed (GtkSearchEntry* _sender,
                                                                                           gpointer self)
{
	scratch_widgets_search_bar_update_search_occurence_label ((ScratchWidgetsSearchBar*) self);
}

static void
_scratch_widgets_search_bar___lambda103_ (ScratchWidgetsSearchBar* self,
                                          GtkEntryIconPosition p0,
                                          GdkEvent* p1)
{
	g_return_if_fail (p1 != NULL);
	if (p0 == GTK_ENTRY_ICON_PRIMARY) {
		scratch_widgets_search_bar_search_next (self);
	}
}

static void
__scratch_widgets_search_bar___lambda103__gtk_entry_icon_release (GtkEntry* _sender,
                                                                  GtkEntryIconPosition icon_pos,
                                                                  GdkEvent* event,
                                                                  gpointer self)
{
	_scratch_widgets_search_bar___lambda103_ ((ScratchWidgetsSearchBar*) self, icon_pos, event);
}

static void
_scratch_widgets_search_bar_on_replace_entry_activate_gtk_entry_activate (GtkEntry* _sender,
                                                                          gpointer self)
{
	scratch_widgets_search_bar_on_replace_entry_activate ((ScratchWidgetsSearchBar*) self);
}

static gboolean
_scratch_widgets_search_bar_on_replace_entry_key_press_gtk_widget_key_press_event (GtkWidget* _sender,
                                                                                   GdkEventKey* event,
                                                                                   gpointer self)
{
	gboolean result;
	result = scratch_widgets_search_bar_on_replace_entry_key_press ((ScratchWidgetsSearchBar*) self, event);
	return result;
}

static GObject *
scratch_widgets_search_bar_constructor (GType type,
                                        guint n_construct_properties,
                                        GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	ScratchWidgetsSearchBar * self;
	GtkStyleContext* _tmp0_;
	GtkSearchEntry* _tmp1_;
	GtkSearchEntry* _tmp2_;
	GtkSearchEntry* _tmp3_;
	GtkLabel* _tmp4_ = NULL;
	ScratchApplication* app_instance = NULL;
	GApplication* _tmp5_;
	ScratchApplication* _tmp6_;
	GtkButton* _tmp7_;
	GtkButton* _tmp8_;
	GtkButton* _tmp9_;
	GtkButton* _tmp10_;
	ScratchApplication* _tmp11_;
	gchar** _tmp12_;
	gchar** _tmp13_;
	gchar** _tmp14_;
	gint _tmp14__length1;
	gchar* _tmp15_;
	gchar* _tmp16_;
	GtkButton* _tmp17_;
	GtkButton* _tmp18_;
	GtkButton* _tmp19_;
	GtkButton* _tmp20_;
	GtkButton* _tmp21_;
	ScratchApplication* _tmp22_;
	gchar** _tmp23_;
	gchar** _tmp24_;
	gchar** _tmp25_;
	gint _tmp25__length1;
	gchar* _tmp26_;
	gchar* _tmp27_;
	GtkImage* _tmp28_;
	gchar* _tmp29_;
	GtkToggleButton* _tmp30_ = NULL;
	GtkToggleButton* _tmp31_;
	GtkToggleButton* _tmp32_;
	GtkImage* _tmp33_;
	GtkToggleButton* _tmp34_ = NULL;
	GtkToggleButton* _tmp35_;
	GtkToggleButton* _tmp36_;
	GtkToggleButton* _tmp37_;
	GtkImage* _tmp38_;
	gchar* _tmp39_;
	GtkToggleButton* _tmp40_ = NULL;
	GtkToggleButton* _tmp41_;
	GtkGrid* search_grid = NULL;
	GtkGrid* _tmp42_;
	GtkGrid* _tmp43_;
	GtkGrid* _tmp44_;
	GtkStyleContext* _tmp45_;
	GtkGrid* _tmp46_;
	GtkSearchEntry* _tmp47_;
	GtkGrid* _tmp48_;
	GtkLabel* _tmp49_;
	GtkGrid* _tmp50_;
	GtkButton* _tmp51_;
	GtkGrid* _tmp52_;
	GtkButton* _tmp53_;
	GtkGrid* _tmp54_;
	GtkToggleButton* _tmp55_;
	GtkGrid* _tmp56_;
	GtkToggleButton* _tmp57_;
	GtkGrid* _tmp58_;
	GtkToggleButton* _tmp59_;
	GtkFlowBoxChild* search_flow_box_child = NULL;
	GtkFlowBoxChild* _tmp60_;
	GtkFlowBoxChild* _tmp61_;
	GtkFlowBoxChild* _tmp62_;
	GtkGrid* _tmp63_;
	GtkSearchEntry* _tmp64_;
	GtkSearchEntry* _tmp65_;
	GtkSearchEntry* _tmp66_;
	GtkSearchEntry* _tmp67_;
	GtkButton* _tmp68_;
	GtkButton* _tmp69_;
	GtkButton* _tmp70_;
	GtkButton* _tmp71_;
	GtkGrid* replace_grid = NULL;
	GtkGrid* _tmp72_;
	GtkGrid* _tmp73_;
	GtkGrid* _tmp74_;
	GtkStyleContext* _tmp75_;
	GtkGrid* _tmp76_;
	GtkSearchEntry* _tmp77_;
	GtkGrid* _tmp78_;
	GtkButton* _tmp79_;
	GtkGrid* _tmp80_;
	GtkButton* _tmp81_;
	GtkFlowBoxChild* replace_flow_box_child = NULL;
	GtkFlowBoxChild* _tmp82_;
	GtkFlowBoxChild* _tmp83_;
	GtkFlowBoxChild* _tmp84_;
	GtkGrid* _tmp85_;
	GtkSearchEntry* _tmp86_;
	GtkSearchEntry* _tmp87_;
	GtkSearchEntry* _tmp88_;
	GtkSearchEntry* _tmp89_;
	GtkSearchEntry* _tmp90_;
	GtkSearchEntry* _tmp91_;
	GtkSearchEntry* _tmp92_;
	GtkWidgetPath* entry_path = NULL;
	GtkWidgetPath* _tmp93_;
	GtkWidgetPath* _tmp94_;
	GtkStyleContext* entry_context = NULL;
	GtkStyleContext* _tmp95_;
	GtkStyleContext* _tmp96_;
	GtkWidgetPath* _tmp97_;
	GtkStyleContext* _tmp98_;
	GtkFlowBoxChild* _tmp99_;
	GtkFlowBoxChild* _tmp100_;
	parent_class = G_OBJECT_CLASS (scratch_widgets_search_bar_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SCRATCH_WIDGETS_TYPE_SEARCH_BAR, ScratchWidgetsSearchBar);
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
	gtk_style_context_add_class (_tmp0_, "search-bar");
	_tmp1_ = (GtkSearchEntry*) gtk_search_entry_new ();
	g_object_ref_sink (_tmp1_);
	_g_object_unref0 (self->search_entry);
	self->search_entry = _tmp1_;
	_tmp2_ = self->search_entry;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp2_, TRUE);
	_tmp3_ = self->search_entry;
	gtk_entry_set_placeholder_text ((GtkEntry*) _tmp3_, _ ("Find"));
	_tmp4_ = (GtkLabel*) gtk_label_new (_ ("no results"));
	gtk_widget_set_margin_start ((GtkWidget*) _tmp4_, 4);
	g_object_ref_sink (_tmp4_);
	_g_object_unref0 (self->priv->search_occurence_count_label);
	self->priv->search_occurence_count_label = _tmp4_;
	_tmp5_ = g_application_get_default ();
	_tmp6_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, SCRATCH_TYPE_APPLICATION, ScratchApplication));
	app_instance = _tmp6_;
	_tmp7_ = (GtkButton*) gtk_button_new_from_icon_name ("go-down-symbolic", (GtkIconSize) GTK_ICON_SIZE_SMALL_TOOLBAR);
	g_object_ref_sink (_tmp7_);
	_g_object_unref0 (self->priv->tool_arrow_down);
	self->priv->tool_arrow_down = _tmp7_;
	_tmp8_ = self->priv->tool_arrow_down;
	g_signal_connect_object (_tmp8_, "clicked", (GCallback) _scratch_widgets_search_bar_search_next_gtk_button_clicked, self, 0);
	_tmp9_ = self->priv->tool_arrow_down;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp9_, FALSE);
	_tmp10_ = self->priv->tool_arrow_down;
	_tmp11_ = app_instance;
	_tmp13_ = _tmp12_ = gtk_application_get_accels_for_action ((GtkApplication*) _tmp11_, SCRATCH_MAIN_WINDOW_ACTION_PREFIX SCRATCH_MAIN_WINDOW_ACTION_FIND_NEXT);
	_tmp14_ = _tmp13_;
	_tmp14__length1 = _vala_array_length (_tmp12_);
	_tmp15_ = granite_markup_accel_tooltip (_tmp14_, (gint) _vala_array_length (_tmp12_), _ ("Search next"));
	_tmp16_ = _tmp15_;
	gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp10_, _tmp16_);
	_g_free0 (_tmp16_);
	_tmp14_ = (_vala_array_free (_tmp14_, _tmp14__length1, (GDestroyNotify) g_free), NULL);
	_tmp17_ = self->priv->tool_arrow_down;
	gtk_widget_set_margin_start ((GtkWidget*) _tmp17_, 4);
	_tmp18_ = (GtkButton*) gtk_button_new_from_icon_name ("go-up-symbolic", (GtkIconSize) GTK_ICON_SIZE_SMALL_TOOLBAR);
	g_object_ref_sink (_tmp18_);
	_g_object_unref0 (self->priv->tool_arrow_up);
	self->priv->tool_arrow_up = _tmp18_;
	_tmp19_ = self->priv->tool_arrow_up;
	g_signal_connect_object (_tmp19_, "clicked", (GCallback) _scratch_widgets_search_bar_search_previous_gtk_button_clicked, self, 0);
	_tmp20_ = self->priv->tool_arrow_up;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp20_, FALSE);
	_tmp21_ = self->priv->tool_arrow_up;
	_tmp22_ = app_instance;
	_tmp24_ = _tmp23_ = gtk_application_get_accels_for_action ((GtkApplication*) _tmp22_, SCRATCH_MAIN_WINDOW_ACTION_PREFIX SCRATCH_MAIN_WINDOW_ACTION_FIND_PREVIOUS);
	_tmp25_ = _tmp24_;
	_tmp25__length1 = _vala_array_length (_tmp23_);
	_tmp26_ = granite_markup_accel_tooltip (_tmp25_, (gint) _vala_array_length (_tmp23_), _ ("Search previous"));
	_tmp27_ = _tmp26_;
	gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp21_, _tmp27_);
	_g_free0 (_tmp27_);
	_tmp25_ = (_vala_array_free (_tmp25_, _tmp25__length1, (GDestroyNotify) g_free), NULL);
	_tmp28_ = (GtkImage*) gtk_image_new_from_icon_name ("media-playlist-repeat-symbolic", (GtkIconSize) GTK_ICON_SIZE_SMALL_TOOLBAR);
	g_object_ref_sink (_tmp28_);
	_tmp29_ = g_strdup (_ ("Cyclic Search"));
	_tmp30_ = (GtkToggleButton*) gtk_toggle_button_new ();
	gtk_button_set_image ((GtkButton*) _tmp30_, (GtkWidget*) _tmp28_);
	_g_object_unref0 (_tmp28_);
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp30_, _tmp29_);
	_g_free0 (_tmp29_);
	g_object_ref_sink (_tmp30_);
	_tmp31_ = _tmp30_;
	scratch_widgets_search_bar_set_tool_cycle_search (self, _tmp31_);
	_g_object_unref0 (_tmp31_);
	_tmp32_ = self->priv->_tool_cycle_search;
	g_signal_connect_object ((GtkButton*) _tmp32_, "clicked", (GCallback) _scratch_widgets_search_bar_on_search_entry_text_changed_gtk_button_clicked, self, 0);
	_tmp33_ = (GtkImage*) gtk_image_new_from_icon_name ("font-select-symbolic", (GtkIconSize) GTK_ICON_SIZE_SMALL_TOOLBAR);
	g_object_ref_sink (_tmp33_);
	_tmp34_ = (GtkToggleButton*) gtk_toggle_button_new ();
	gtk_button_set_image ((GtkButton*) _tmp34_, (GtkWidget*) _tmp33_);
	_g_object_unref0 (_tmp33_);
	g_object_ref_sink (_tmp34_);
	_g_object_unref0 (self->priv->case_sensitive_button);
	self->priv->case_sensitive_button = _tmp34_;
	_tmp35_ = self->priv->case_sensitive_button;
	_tmp36_ = self->priv->case_sensitive_button;
	g_object_bind_property_with_closures ((GObject*) _tmp35_, "active", (GObject*) _tmp36_, "tooltip-text", G_BINDING_DEFAULT | G_BINDING_SYNC_CREATE, (GClosure*) ((__scratch_widgets_search_bar___lambda102__gbinding_transform_func == NULL) ? NULL : g_cclosure_new ((GCallback) __scratch_widgets_search_bar___lambda102__gbinding_transform_func, g_object_ref (self), (GClosureNotify) g_object_unref)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp37_ = self->priv->case_sensitive_button;
	g_signal_connect_object ((GtkButton*) _tmp37_, "clicked", (GCallback) _scratch_widgets_search_bar_on_search_entry_text_changed_gtk_button_clicked, self, 0);
	_tmp38_ = (GtkImage*) gtk_image_new_from_icon_name ("text-html-symbolic", (GtkIconSize) GTK_ICON_SIZE_SMALL_TOOLBAR);
	g_object_ref_sink (_tmp38_);
	_tmp39_ = g_strdup (_ ("Use regular expressions"));
	_tmp40_ = (GtkToggleButton*) gtk_toggle_button_new ();
	gtk_button_set_image ((GtkButton*) _tmp40_, (GtkWidget*) _tmp38_);
	_g_object_unref0 (_tmp38_);
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp40_, _tmp39_);
	_g_free0 (_tmp39_);
	g_object_ref_sink (_tmp40_);
	_g_object_unref0 (self->priv->tool_regex_button);
	self->priv->tool_regex_button = _tmp40_;
	_tmp41_ = self->priv->tool_regex_button;
	g_signal_connect_object ((GtkButton*) _tmp41_, "clicked", (GCallback) _scratch_widgets_search_bar_on_search_entry_text_changed_gtk_button_clicked, self, 0);
	_tmp42_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp42_);
	search_grid = _tmp42_;
	_tmp43_ = search_grid;
	g_object_set ((GtkWidget*) _tmp43_, "margin", 3, NULL);
	_tmp44_ = search_grid;
	_tmp45_ = gtk_widget_get_style_context ((GtkWidget*) _tmp44_);
	gtk_style_context_add_class (_tmp45_, GTK_STYLE_CLASS_LINKED);
	_tmp46_ = search_grid;
	_tmp47_ = self->search_entry;
	gtk_container_add ((GtkContainer*) _tmp46_, (GtkWidget*) _tmp47_);
	_tmp48_ = search_grid;
	_tmp49_ = self->priv->search_occurence_count_label;
	gtk_container_add ((GtkContainer*) _tmp48_, (GtkWidget*) _tmp49_);
	_tmp50_ = search_grid;
	_tmp51_ = self->priv->tool_arrow_down;
	gtk_container_add ((GtkContainer*) _tmp50_, (GtkWidget*) _tmp51_);
	_tmp52_ = search_grid;
	_tmp53_ = self->priv->tool_arrow_up;
	gtk_container_add ((GtkContainer*) _tmp52_, (GtkWidget*) _tmp53_);
	_tmp54_ = search_grid;
	_tmp55_ = self->priv->_tool_cycle_search;
	gtk_container_add ((GtkContainer*) _tmp54_, (GtkWidget*) _tmp55_);
	_tmp56_ = search_grid;
	_tmp57_ = self->priv->case_sensitive_button;
	gtk_container_add ((GtkContainer*) _tmp56_, (GtkWidget*) _tmp57_);
	_tmp58_ = search_grid;
	_tmp59_ = self->priv->tool_regex_button;
	gtk_container_add ((GtkContainer*) _tmp58_, (GtkWidget*) _tmp59_);
	_tmp60_ = (GtkFlowBoxChild*) gtk_flow_box_child_new ();
	g_object_ref_sink (_tmp60_);
	search_flow_box_child = _tmp60_;
	_tmp61_ = search_flow_box_child;
	gtk_widget_set_can_focus ((GtkWidget*) _tmp61_, FALSE);
	_tmp62_ = search_flow_box_child;
	_tmp63_ = search_grid;
	gtk_container_add ((GtkContainer*) _tmp62_, (GtkWidget*) _tmp63_);
	_tmp64_ = (GtkSearchEntry*) gtk_search_entry_new ();
	g_object_ref_sink (_tmp64_);
	_g_object_unref0 (self->replace_entry);
	self->replace_entry = _tmp64_;
	_tmp65_ = self->replace_entry;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp65_, TRUE);
	_tmp66_ = self->replace_entry;
	gtk_entry_set_placeholder_text ((GtkEntry*) _tmp66_, _ ("Replace With"));
	_tmp67_ = self->replace_entry;
	gtk_entry_set_icon_from_icon_name ((GtkEntry*) _tmp67_, GTK_ENTRY_ICON_PRIMARY, "edit-symbolic");
	_tmp68_ = (GtkButton*) gtk_button_new_with_label (_ ("Replace"));
	g_object_ref_sink (_tmp68_);
	_g_object_unref0 (self->priv->replace_tool_button);
	self->priv->replace_tool_button = _tmp68_;
	_tmp69_ = self->priv->replace_tool_button;
	g_signal_connect_object (_tmp69_, "clicked", (GCallback) _scratch_widgets_search_bar_on_replace_entry_activate_gtk_button_clicked, self, 0);
	_tmp70_ = (GtkButton*) gtk_button_new_with_label (_ ("Replace all"));
	g_object_ref_sink (_tmp70_);
	_g_object_unref0 (self->priv->replace_all_tool_button);
	self->priv->replace_all_tool_button = _tmp70_;
	_tmp71_ = self->priv->replace_all_tool_button;
	g_signal_connect_object (_tmp71_, "clicked", (GCallback) _scratch_widgets_search_bar_on_replace_all_entry_activate_gtk_button_clicked, self, 0);
	_tmp72_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp72_);
	replace_grid = _tmp72_;
	_tmp73_ = replace_grid;
	g_object_set ((GtkWidget*) _tmp73_, "margin", 3, NULL);
	_tmp74_ = replace_grid;
	_tmp75_ = gtk_widget_get_style_context ((GtkWidget*) _tmp74_);
	gtk_style_context_add_class (_tmp75_, GTK_STYLE_CLASS_LINKED);
	_tmp76_ = replace_grid;
	_tmp77_ = self->replace_entry;
	gtk_container_add ((GtkContainer*) _tmp76_, (GtkWidget*) _tmp77_);
	_tmp78_ = replace_grid;
	_tmp79_ = self->priv->replace_tool_button;
	gtk_container_add ((GtkContainer*) _tmp78_, (GtkWidget*) _tmp79_);
	_tmp80_ = replace_grid;
	_tmp81_ = self->priv->replace_all_tool_button;
	gtk_container_add ((GtkContainer*) _tmp80_, (GtkWidget*) _tmp81_);
	_tmp82_ = (GtkFlowBoxChild*) gtk_flow_box_child_new ();
	g_object_ref_sink (_tmp82_);
	replace_flow_box_child = _tmp82_;
	_tmp83_ = replace_flow_box_child;
	gtk_widget_set_can_focus ((GtkWidget*) _tmp83_, FALSE);
	_tmp84_ = replace_flow_box_child;
	_tmp85_ = replace_grid;
	gtk_container_add ((GtkContainer*) _tmp84_, (GtkWidget*) _tmp85_);
	_tmp86_ = self->search_entry;
	g_signal_connect_object ((GtkEditable*) _tmp86_, "changed", (GCallback) _scratch_widgets_search_bar_on_search_entry_text_changed_gtk_editable_changed, self, 0);
	_tmp87_ = self->search_entry;
	g_signal_connect_object ((GtkWidget*) _tmp87_, "key-press-event", (GCallback) _scratch_widgets_search_bar_on_search_entry_key_press_gtk_widget_key_press_event, self, 0);
	_tmp88_ = self->search_entry;
	g_signal_connect_object ((GtkWidget*) _tmp88_, "focus-in-event", (GCallback) _scratch_widgets_search_bar_on_search_entry_focused_in_gtk_widget_focus_in_event, self, 0);
	_tmp89_ = self->search_entry;
	g_signal_connect_object (_tmp89_, "search-changed", (GCallback) _scratch_widgets_search_bar_update_search_occurence_label_gtk_search_entry_search_changed, self, 0);
	_tmp90_ = self->search_entry;
	g_signal_connect_object ((GtkEntry*) _tmp90_, "icon-release", (GCallback) __scratch_widgets_search_bar___lambda103__gtk_entry_icon_release, self, 0);
	_tmp91_ = self->replace_entry;
	g_signal_connect_object ((GtkEntry*) _tmp91_, "activate", (GCallback) _scratch_widgets_search_bar_on_replace_entry_activate_gtk_entry_activate, self, 0);
	_tmp92_ = self->replace_entry;
	g_signal_connect_object ((GtkWidget*) _tmp92_, "key-press-event", (GCallback) _scratch_widgets_search_bar_on_replace_entry_key_press_gtk_widget_key_press_event, self, 0);
	_tmp93_ = gtk_widget_path_new ();
	entry_path = _tmp93_;
	_tmp94_ = entry_path;
	gtk_widget_path_append_type (_tmp94_, gtk_widget_get_type ());
	_tmp95_ = gtk_style_context_new ();
	entry_context = _tmp95_;
	_tmp96_ = entry_context;
	_tmp97_ = entry_path;
	gtk_style_context_set_path (_tmp96_, _tmp97_);
	_tmp98_ = entry_context;
	gtk_style_context_add_class (_tmp98_, "entry");
	gtk_flow_box_set_selection_mode ((GtkFlowBox*) self, GTK_SELECTION_NONE);
	gtk_flow_box_set_column_spacing ((GtkFlowBox*) self, (guint) 6);
	gtk_flow_box_set_max_children_per_line ((GtkFlowBox*) self, (guint) 2);
	_tmp99_ = search_flow_box_child;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp99_);
	_tmp100_ = replace_flow_box_child;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp100_);
	scratch_widgets_search_bar_update_replace_tool_sensitivities (self, FALSE);
	_g_object_unref0 (entry_context);
	_gtk_widget_path_unref0 (entry_path);
	_g_object_unref0 (replace_flow_box_child);
	_g_object_unref0 (replace_grid);
	_g_object_unref0 (search_flow_box_child);
	_g_object_unref0 (search_grid);
	_g_object_unref0 (app_instance);
	return obj;
}

static void
scratch_widgets_search_bar_class_init (ScratchWidgetsSearchBarClass * klass,
                                       gpointer klass_data)
{
	scratch_widgets_search_bar_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &ScratchWidgetsSearchBar_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_scratch_widgets_search_bar_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_scratch_widgets_search_bar_set_property;
	G_OBJECT_CLASS (klass)->constructor = scratch_widgets_search_bar_constructor;
	G_OBJECT_CLASS (klass)->finalize = scratch_widgets_search_bar_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), SCRATCH_WIDGETS_SEARCH_BAR_WINDOW_PROPERTY, scratch_widgets_search_bar_properties[SCRATCH_WIDGETS_SEARCH_BAR_WINDOW_PROPERTY] = g_param_spec_object ("window", "window", "window", SCRATCH_TYPE_MAIN_WINDOW, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	/**
	         * Is the search cyclic? e.g., when you are at the bottom, if you press
	         * "Down", it will go at the start of the file to search for the content
	         * of the search entry.
	         **/
	g_object_class_install_property (G_OBJECT_CLASS (klass), SCRATCH_WIDGETS_SEARCH_BAR_TOOL_CYCLE_SEARCH_PROPERTY, scratch_widgets_search_bar_properties[SCRATCH_WIDGETS_SEARCH_BAR_TOOL_CYCLE_SEARCH_PROPERTY] = g_param_spec_object ("tool-cycle-search", "tool-cycle-search", "tool-cycle-search", gtk_toggle_button_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	scratch_widgets_search_bar_signals[SCRATCH_WIDGETS_SEARCH_BAR_SEARCH_EMPTY_SIGNAL] = g_signal_new ("search-empty", SCRATCH_WIDGETS_TYPE_SEARCH_BAR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

static void
scratch_widgets_search_bar_instance_init (ScratchWidgetsSearchBar * self,
                                          gpointer klass)
{
	self->priv = scratch_widgets_search_bar_get_instance_private (self);
	self->priv->text_view = NULL;
	self->priv->text_buffer = NULL;
	self->priv->search_context = NULL;
	self->priv->update_search_label_timeout_id = (guint) 0;
}

static void
scratch_widgets_search_bar_finalize (GObject * obj)
{
	ScratchWidgetsSearchBar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SCRATCH_WIDGETS_TYPE_SEARCH_BAR, ScratchWidgetsSearchBar);
	_g_object_unref0 (self->priv->tool_arrow_up);
	_g_object_unref0 (self->priv->tool_arrow_down);
	_g_object_unref0 (self->priv->_tool_cycle_search);
	_g_object_unref0 (self->priv->case_sensitive_button);
	_g_object_unref0 (self->priv->tool_regex_button);
	_g_object_unref0 (self->search_entry);
	_g_object_unref0 (self->replace_entry);
	_g_object_unref0 (self->priv->search_occurence_count_label);
	_g_object_unref0 (self->priv->replace_tool_button);
	_g_object_unref0 (self->priv->replace_all_tool_button);
	_g_object_unref0 (self->priv->text_view);
	_g_object_unref0 (self->priv->text_buffer);
	_g_object_unref0 (self->priv->search_context);
	G_OBJECT_CLASS (scratch_widgets_search_bar_parent_class)->finalize (obj);
}

static GType
scratch_widgets_search_bar_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ScratchWidgetsSearchBarClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) scratch_widgets_search_bar_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ScratchWidgetsSearchBar), 0, (GInstanceInitFunc) scratch_widgets_search_bar_instance_init, NULL };
	GType scratch_widgets_search_bar_type_id;
	scratch_widgets_search_bar_type_id = g_type_register_static (gtk_flow_box_get_type (), "ScratchWidgetsSearchBar", &g_define_type_info, 0);
	ScratchWidgetsSearchBar_private_offset = g_type_add_instance_private (scratch_widgets_search_bar_type_id, sizeof (ScratchWidgetsSearchBarPrivate));
	return scratch_widgets_search_bar_type_id;
}

GType
scratch_widgets_search_bar_get_type (void)
{
	static volatile gsize scratch_widgets_search_bar_type_id__volatile = 0;
	if (g_once_init_enter (&scratch_widgets_search_bar_type_id__volatile)) {
		GType scratch_widgets_search_bar_type_id;
		scratch_widgets_search_bar_type_id = scratch_widgets_search_bar_get_type_once ();
		g_once_init_leave (&scratch_widgets_search_bar_type_id__volatile, scratch_widgets_search_bar_type_id);
	}
	return scratch_widgets_search_bar_type_id__volatile;
}

static void
_vala_scratch_widgets_search_bar_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec)
{
	ScratchWidgetsSearchBar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SCRATCH_WIDGETS_TYPE_SEARCH_BAR, ScratchWidgetsSearchBar);
	switch (property_id) {
		case SCRATCH_WIDGETS_SEARCH_BAR_WINDOW_PROPERTY:
		g_value_set_object (value, scratch_widgets_search_bar_get_window (self));
		break;
		case SCRATCH_WIDGETS_SEARCH_BAR_TOOL_CYCLE_SEARCH_PROPERTY:
		g_value_set_object (value, scratch_widgets_search_bar_get_tool_cycle_search (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_scratch_widgets_search_bar_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec)
{
	ScratchWidgetsSearchBar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SCRATCH_WIDGETS_TYPE_SEARCH_BAR, ScratchWidgetsSearchBar);
	switch (property_id) {
		case SCRATCH_WIDGETS_SEARCH_BAR_WINDOW_PROPERTY:
		scratch_widgets_search_bar_set_window (self, g_value_get_object (value));
		break;
		case SCRATCH_WIDGETS_SEARCH_BAR_TOOL_CYCLE_SEARCH_PROPERTY:
		scratch_widgets_search_bar_set_tool_cycle_search (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

